! To do list:
! - semi-automatic border handling: overwrite singe parameters
! - ECP handling in get_coords ?
! - assumed charges for layers based on LMOs
! - integrating embedding into the infrastructure
! - electronic embedding: gradient with regenerated chages
! - electronic embedding: with Adam's new atomic charges (chelp?) 
! - electronic embedding: point charge handling at the border 
! - electronic embedding: PCM with point charges does not work
! - memory allocation of strings
************************************************************************
      subroutine oniomcore(oniom,gopt,freq,qmmm)
************************************************************************
* Core routine for ONIOM calculations
************************************************************************
#include "MRCCCOMMON"
      integer :: nsp,nlay,natoms,ncent,natwdummy
      integer :: oniomem
      integer,          dimension(:,:),  allocatable  :: layeratoms
      integer,          dimension(:),    allocatable  :: ind
      integer,          dimension(:,:,:),allocatable  :: borderat
      integer,          dimension(:,:),  allocatable  :: bondord
      double precision, dimension(:),    allocatable  :: atchg
      double precision, dimension(:),    allocatable  :: satchg
      double precision, dimension(:,:),  allocatable  :: coord
      double precision, dimension(:,:),  allocatable  :: scoord
      double precision, dimension(:,:),  allocatable  :: force
      double precision, dimension(:,:),  allocatable  :: efield
      double precision, dimension(:,:,:),allocatable  :: linkcoord
      double precision, dimension(:,:),  allocatable  :: linkdist
      double precision, dimension(:),    allocatable  :: eecharge
      character(len=4)    :: geom,oniomtype
      character(len=8)    :: gopt,freq,oniom,qmmm
      character(len=16)   :: mem,oldmem,coniomem
      character(len=:),                  allocatable  :: string
      character(len=:),                  allocatable  :: bordstring
      character(len=:),                  allocatable  :: linkstring
      character(len=:),                  allocatable  :: diststring
      logical             :: llg
      open(minpfile,file='MINP')
       call getkeym('geom',4,geom,4)
      close(minpfile)
      call get_natoms(minpfile,geom,natwdummy,natoms)
      call get_nmmcharges(minpfile,natwdummy,ncent,qmmm)
      call get_layernumber_oniomtype(oniom,nlay,oniomtype)
      write(iout,*)
      write(iout,"(' An ONIOM calculation is requested with',i2,'
     $ layers.')"),nlay
      if    (oniomtype.eq.'me') then
       write(iout,"(' Mechanical embedding will be utilized.')")
      elseif(oniomtype.eq.'ee') then
       write(iout,"(' Electronic embedding will be utilized.')")
      endif
      nsp=(nlay-1)*2+1
      ! Cleanup existing input files
      call cleaup_oniom(nsp,minpfile)
      ! calculate necessary memory and redefine requested memory
      write(iout,*)
      write(iout,'(a)') ' Allocating memory for ONIOM calculation...'
      oniomem=natoms*nlay*153+natoms*2+ncent*14+1
      call getkey('mem',3,oldmem,16)
      call modify_mem(oldmem,mem,oniomem,coniomem,iout)
      write(iout,"(' The ammount of requested memory: 
     $',a16)"),trim(adjustl(oldmem))
      write(iout,"(' Memory requirement of ONIOM specific arrays: 
     $',a16)"),trim(adjustl(coniomem))
      write(iout,"(' The remaining ammount of the requested memory: 
     $',a16)"),trim(adjustl(mem))
      write(iout,*)
      ! allocate memory
      allocate(layeratoms(natoms,nlay))
      allocate(ind(natoms+1))
      allocate(atchg(ncent))
      allocate(satchg(ncent))
      allocate(coord(3,ncent))
      allocate(scoord(3,ncent))
      allocate(force(3,ncent))
      allocate(efield(3,ncent))
      allocate(linkcoord(3,natoms,nlay))
      allocate(borderat(2,natoms,nlay))
      allocate(bondord(natoms,nlay))
      allocate(linkdist(natoms,nlay))
      allocate(eecharge(natoms))
      allocate(character(8*8*natoms)      :: string)
      allocate(character(8*4*natoms*nlay) :: bordstring)
      allocate(character(8*3*natoms*nlay) :: linkstring)
      allocate(character(8*3*natoms*nlay) :: diststring)
      call oniomdriver(gopt,freq,qmmm,nsp,nlay,natoms,minpfile,
     $scrfile1,layeratoms,ind,iout,ncent,atchg,coord,angtobohr,
     $satchg,scoord,mem,natwdummy,borderat,bondord,linkdist,
     $linkcoord,string,bordstring,linkstring,diststring,force,efield,
     $ifltln,echesu,oniomtype,eecharge)
      deallocate(layeratoms)
      deallocate(ind)
      deallocate(atchg)
      deallocate(satchg)
      deallocate(coord)
      deallocate(scoord)
      deallocate(force)
      deallocate(efield)
      deallocate(linkcoord)
      deallocate(borderat)
      deallocate(bondord)
      deallocate(linkdist)
      deallocate(string)
      deallocate(bordstring)
      deallocate(linkstring)
      deallocate(diststring)
      deallocate(eecharge)
      open(minpfile,file='ONIOMROUTE')
      close(minpfile,status='delete')
      call changekey('mem',3,oldmem,16)
      return
      end
C

************************************************************************
      subroutine oniomdriver(gopt,freq,qmmm,nsp,nlay,natoms,minpfile,
     $scrfile1,layeratoms,ind,iout,ncent,atchg,coord,
     $angtobohr,satchg,scoord,mem,natwdummy,borderat,bondord,
     $linkdist,linkcoord,istring,borderstring,linkstring,diststring,
     $force,efield,ifltln,echesu,oniomtype,eecharge)
************************************************************************
* Driver routine for ONIOM calculations
************************************************************************
      implicit none
      integer natoms,minpfile,nlay,nsp,ilay,isp,i,iout,scrfile1,ifltln
      integer ncent,level,iatoms,jatoms,natwdummy,icent
      integer layeratoms(natoms,nlay),natomslay(nlay),ind(natoms+1)
      integer ichg(nlay),imul(nlay),nborders(nlay),nkeys,nkeysnon
      integer borderat(2,natoms,nlay),nlinks(nlay),bondord(natoms,nlay)
      integer laykey,nmrcckeys,npcmkeys,npcmdefkeys,ncharge(nlay)
      integer nnotlayat(nlay)
      character*1 borderstat(natoms,nlay)
      character*2 atsymbol(natwdummy),satsymbol(natwdummy)
      character*2 linksym(natoms,nlay),slinksym(natoms,nlay)
      character*2 cisp
      character*3 moldenval
      character*4 verbosity,dens,geom,uval,sdens,mpitasks
      character*4 borderhand(nlay),oniomtype,soniomtype
      character*7 scfiguess
      character*8 gopt,qmmm,freq,subminp,oniom_pcm,oniom_eechg
      character*16 mem,orbloco,orblocc,orbloce
      character*20 ibas(nlay)
      character*32 imet(nlay),pcm
      character*1024 pcmkeys,pcmkeystring,mrcckeys
      character*1024 filterstring
      character*2048 keywstring
      character(len=natoms*8*8) istring
      character(len=natoms*4*8) borderstring(nlay)
      character(len=natoms*3*8) linkstring(nlay),diststring(nlay)
      real*8 coord(3,ncent),atchg(ncent),linkdist(natoms,nlay)
      real*8 force(3,ncent),efield(3,ncent)
      real*8 scoord(3,ncent),satchg(ncent)
      real*8 linkcoord(3,natoms,nlay),eecharge(natoms),rscr
      real*8 cput,walt,orbcpu,orbwal,angtobohr,echesu,finalener
      logical llg,usetemp,firstcall
      ! Initalize variables + call for keys + mrcc/pcm key handling
      call oniomdriverinit(firstcall,usetemp,borderhand,linkdist,imet,
     $ibas,borderstat,sdens,nlinks,borderstring,linkstring,diststring,
     $coord,force,efield,atchg,eecharge,layeratoms,borderat,linksym,
     $pcmkeystring,mrcckeys,nmrcckeys,pcmkeys,npcmkeys,nkeys,
     $npcmdefkeys,nkeysnon,subminp,verbosity,dens,geom,uval,orblocc,
     $orbloco,orbloce,moldenval,mpitasks,pcm,oniom_pcm,oniom_eechg,
     $ncent,natoms,natwdummy,slinksym,nlay,keywstring,filterstring,iout,
     $oniomtype)
      ! 
      call get_firstcall(firstcall,moldenval,qmmm,gopt,freq,scrfile1,
     $minpfile)
      ! Setup coordinates
      call get_coords(qmmm,minpfile,scrfile1,natoms,natwdummy,
     $iout,coord,atchg,atsymbol,angtobohr,uval,ncent)
      if(firstcall) then
       call ishell('rm -f ONIOMSPEC')
       ! Setup ONIOM layer specifications
       call setup_oniomspec(nlay,natwdummy,minpfile,layeratoms,
     $natomslay,ind,imet,ibas,ichg,imul,iout,natwdummy,
     $borderat,atsymbol,borderhand,linksym,linkdist,
     $borderstat,istring,borderstring,linkstring,diststring,usetemp,
     $subminp)
       ! get the specifications from the MINP file
       call get_keylist(minpfile,keywstring,2048,scrfile1,nkeys)
       call get_nonmust_keylist(keywstring,2048,nkeys,filterstring,1024,
     $nkeysnon)
       call get_complete_keys(minpfile,keywstring,2048,nkeys)
       if(trim(adjustl(pcm)).ne.'off') then
        call get_pcmkeylist(minpfile,pcmkeystring,1024,npcmdefkeys,
     $pcmkeys,npcmkeys)
        call get_complete_keys(minpfile,pcmkeystring,1024,npcmdefkeys)
       endif
      else
       call read_oniomspec(scrfile1,nlay,natwdummy,natoms,layeratoms,
     $natomslay,imet,ibas,ichg,imul,borderat,borderhand,linksym,
     $linkdist,borderstat,keywstring,2048,nkeys,pcmkeystring,1024,
     $npcmdefkeys,eecharge)
      endif
      ! ################### Main loop starts ######################
      ilay=1
      level=0
      do isp=1,nsp 
       open(minpfile,file='ONIOMROUTE',form='UNFORMATTED')
        write(minpfile) isp,oniomtype
       close(minpfile)
       scoord=0.0d0
       satchg=0.0d0
       sdens=dens
       if(MOD(isp,2).eq.0) then 
        ilay=ilay+1
       else
        level=level+1
       endif
       write(iout,*)
       write(iout,'(a)') ' ============================================
     $=========================='
       write(iout,"(' ***                   Starting calculation #',i2,'
     $                     ***')") isp
       write(iout,'(a)') ' ============================================
     $=========================='
       if(isp.eq.1) then
        call ishell('cp MINP MINP.composite')
        call ishell('cp KEYWD KEYWD.composite')
        read(dens,'(i2)') i
        if(i.eq.0.and.oniomtype.eq.'ee'.and.oniom_eechg.ne.'user') 
     $   sdens='1   '
         soniomtype='    '
       else if(isp.eq.2) then
        if(trim(adjustl(pcm)).ne.'off'.and.
     $     trim(adjustl(oniom_pcm)).eq.'x') then
         npcmdefkeys=npcmdefkeys+2
         pcmkeystring=trim(adjustl(pcmkeystring))//
     $' pcm_cavity_type=restart pcm_cavity_npzFile=cavity.npz'
         soniomtype=oniomtype
        else
         pcm='off                             '
         soniomtype=oniomtype
        endif
       endif
       if(subminp.eq.'top'.or.subminp.eq.'t+t') then
        if(isp.ne.nsp) then 
         laykey=0
        else
         laykey=nkeys
        endif
       else if(subminp.eq.'temp') then
        laykey=0
       else if(subminp.eq.'minp'.or.subminp.eq.'m+t') then
        laykey=nkeys
       endif
       ! Fill coordinate scratch arrays
       call fill_coords(natoms,natwdummy,nlay,ilay,natomslay,layeratoms,
     $icent,coord,scoord,atsymbol,satsymbol,nlinks,linkcoord,slinksym,
     $qmmm,ncent,atchg,satchg,soniomtype,eecharge,force,ncharge,
     $nnotlayat)
       ! Generate MINP file
       call write_minp(qmmm,sdens,isp,minpfile,
     $natomslay(ilay)+nlinks(ilay),natomslay(ilay)+nlinks(ilay),
     $icent,scoord,satsymbol,satchg,imet(level),ibas(level),ichg(ilay),
     $imul(ilay),iout,mem,geom,usetemp,verbosity,uval,laykey,keywstring,
     $2048,mpitasks,pcm,pcmkeystring,npcmdefkeys,soniomtype,force,
     $ncharge(ilay))
       write(iout,*)
       write(cisp,'(i2)') isp
       cisp=trim(adjustl(cisp))
       call ishell('cp MINP.'//cisp//' MINP')
       ! Get calculation specific keys
       if(firstcall) then
        call runit('minp',cput,walt)
        if(oniomtype.eq.'ee'.and.oniom_eechg.eq.'iao'.and.isp.eq.1) then
         call changekey('popul',5,'iao     ',8)
        endif
        if(oniomtype.eq.'ee'.and.isp.gt.1) then
         call changekey('qmmm',4,'amber   ',8)
        endif
       else
        call ishell('cp KEYWD.'//cisp//' KEYWD')
        call changekey('scfiguess',9,'restart',7) 
       endif
       call getkey('scfiguess',9,scfiguess,7)
       if(scfiguess.eq.'restart') then
        inquire(file='SCFDENSITIES.'//cisp,exist=llg)
        if(llg) then
         write(iout,*)
         write(iout,*) ' SCFDENSITIES.'//cisp//' is found!'
         call ishell('cp SCFDENSITIES.'//cisp//' SCFDENSITIES')
        else
         write(iout,*) 
         write(iout,'(a)') ' Warning! Cannot restart calculation 
     $from SCFDENSITIES.'//cisp//' (the file was not found).' 
         write(iout,'(a)') ' The default inital guess for the 
     $density will be used...'
         call changekey('scfiguess',9,'sad',3)
        endif
       endif
       call ishell('cp KEYWD KEYWD.'//cisp)
       ! Begin calculation
       call spoint(.true.)
       write(iout,*)
       write(iout,'(a)') ' ============================================
     $=========================='
       write(iout,"(' ***                 Calculation #',i2,' is 
     $finished                    ***')") isp
       write(iout,'(a)') ' ============================================
     $=========================='
       if(isp.eq.1) then
        if(firstcall) then
         if(moldenval.ne.'off') then
          call ishell('cp MOLDEN MOLDEN.composite')
         endif
         call changekey('orbloco',7,orbloce,16)
         call changekey('orblocc',7,orbloce,16)
         call ishell('cp MOCOEF MOCOEF.CAN.'//cisp)
         call runit('orbloc',orbcpu,orbwal)
         call ishell('cp MOCOEF MOCOEF.LOC.'//cisp)
         call runit('qmmod',orbcpu,orbwal)
         call ishell('cp MOCOEF.CAN.'//cisp//' MOCOEF')
         call changekey('orbloco',7,orbloco,16)
         call changekey('orblocc',7,orblocc,16)
         call search_layerborders(nlay,natoms,natwdummy,scrfile1,
     $natomslay,layeratoms,nborders,borderat,bondord,iout,
     $atsymbol,linksym,borderhand,borderstat)
         call set_linkdist(nlay,natoms,natwdummy,borderat,nborders,iout,
     $linksym,linkdist,borderhand,atsymbol,borderstat,uval,angtobohr)
        endif
        call set_linkcoords(nlay,natwdummy,natoms,coord,borderat,iout,
     $linkdist,nborders,borderstat,linkcoord,nlinks,linksym,slinksym,
     $ncent)
        if(firstcall) then
         if(oniomtype.eq.'ee') then
          call read_eecharge(oniom_eechg,eecharge,natoms,scrfile1,iout,
     $minpfile)
         endif
         call print_layerborders(nlay,natoms,natwdummy,scrfile1,
     $natomslay,layeratoms,nborders,borderat,bondord,iout,
     $atsymbol,linksym,borderhand,linkdist,borderstat,uval,linkcoord,
     $nlinks)
         call write_oniomspec(scrfile1,nlay,nborders,borderstat,
     $borderat,linksym,linkdist,natoms,eecharge,natomslay,layeratoms,
     $imet,ibas,ichg,imul,borderhand,nkeys,keywstring,npcmdefkeys,
     $pcmkeystring,2048,1024)
        endif
        call ishell('cp COORD.xyz COORD.xyz.composite')
       endif
       read(dens,'(i2)') i
       if((gopt.ne.'off     '.or.freq.ne.'off     ').or.
     $    (i.gt.1)) then
        call ishell('cp GRAD GRAD.'//cisp)
        if(qmmm.eq.'amber'.or.(oniomtype.eq.'ee'.and.isp.gt.1)) 
     $  call ishell('cp mrcc_job.dat mrcc_job.dat.'//cisp)
       endif
       call ishell('cp iface iface.'//cisp)
       call ishell('cp VARS VARS.'//cisp)
       call ishell('cp SCFDENSITIES SCFDENSITIES.'//cisp)
      enddo 
      ! ################### Main loop ends ######################
      call ishell('cp MINP.composite MINP')
      call ishell('cp KEYWD.composite KEYWD')
      call ishell('rm -f VARS')
      if(moldenval.ne.'off') then
       call ishell('cp MOLDEN.composite MOLDEN')
       call ishell('cp COORD.xyz.composite COORD.xyz')
      endif
      call print_results(nsp,nlay,imet,ibas,iout,scrfile1,minpfile,
     $finalener)
      ! Gradient
      read(dens,'(i2)') i
      if(gopt.ne.'off'.or.freq.ne.'off'.or.i.gt.1) then
       call oniomgrad(natoms,natwdummy,nlay,natomslay,layeratoms,
     $icent,coord,scoord,atsymbol,satsymbol,nlinks,linkcoord,
     $slinksym,ncent,atchg,satchg,nsp,iout,scrfile1,borderat,linkdist,
     $angtobohr,uval,force,efield,echesu,finalener,qmmm,ncharge,
     $oniomtype,eecharge)
       open(scrfile1,file='VARS',form='UNFORMATTED')
        write(scrfile1) 'centmass  ',3*ifltln,0.d0,0.d0,0.d0 !!! helo
        write(scrfile1) 'ten       ',9*ifltln,
     $1.d0,0.d0,0.d0,0.d0,1.d0,0.d0,0.d0,0.d0,1.d0
       close(scrfile1)
      endif
      return
      end
C
************************************************************************
      subroutine setup_oniomspec(nlay,natoms,minpfile,layeratoms,
     $natomslay,ind,imet,ibas,ichg,imul,iout,natwdummy,
     $borderat,atsymbol,borderhand,linksym,linkdist,
     $borderstat,cscrk,border,linkat,linksd,usetemp,subminp)
************************************************************************
* Read and set ONIOM layer specifications
************************************************************************
      implicit none
      integer nlay,natoms,ilay,i,j,iout,minpfile,iatom,k,natwdummy
      integer ind(natwdummy+1),ichg(nlay),imul(nlay),isp,nsp
      integer layeratoms(natwdummy,nlay),natomslay(nlay)
      integer borderat(2,natoms,nlay),stringsize
      character*1 borderstat(natoms,nlay)
      character*2 atsymbol(natwdummy),linksym(natoms,nlay),cscr2
      character*4 cscr4,cchg(nlay),borderhand(nlay)
      character*4 cmul(nlay)
      character*8 oniom,cscr8,subminp
      character*16 cscr16
      character*32 imet(nlay) 
      character*20 ibas(nlay)
      character(len=natoms*4*8) border(nlay)
      character(len=natoms*3*8) linkat(nlay),linksd(nlay)
      character(len=8*natoms*8) cscrk
      real*8 linkdist(natoms,nlay)
      logical llg,usetemp
      stringsize=8*natoms*8
      !
      open(minpfile,file='MINP')
       call getkeym('calc',4,imet(nlay),32)
       call getkey('basis',5,ibas(nlay),20)
       call getkey('mult',4,cscr4,4)
       if(cscr4.eq.'    ') then
        imul(nlay)=0
       else
        read(cscr4,'(i4)') imul(nlay)
       endif
       call getkey('charge',6,cchg(nlay),4)
       if(cscr4.eq.'0   ') then
        cchg(nlay)='none'
       endif
       call getkeym('oniom',5,oniom,8)
       ! initalize
       natomslay=0
       layeratoms=0
       imet(1:nlay-1)=' '
       ibas(1:nlay-1)=' '
       imul(1:nlay-1)=0
       cchg(1:nlay-1)=' '
       cmul(1:nlay-1)=' '
       border(1:nlay)=' '
       linkat(1:nlay)=' '
       linksd(1:nlay)=' '
       do ilay=1,nlay
        ! Set full system conditions for the lowest layer
        if(ilay.eq.1) then
         natomslay(ilay)=natwdummy
         do iatom=1,natoms
          layeratoms(iatom,ilay)=iatom
         enddo
        else
         ! Read upper layer atoms
         call oniomat(natwdummy,minpfile,ind,iout)
         k=0
         do iatom=1,natoms
          if(ind(iatom).eq.1) then
           k=k+1
           layeratoms(k,ilay)=iatom
          endif
         enddo
         natomslay(ilay)=k 
         call oniomreadspec(natoms,iout,ind,cscrk,stringsize,
     $minpfile,imet,ibas,cchg,cmul,ilay,nlay,imul,borderhand,
     $border,linkat,linksd) 
        endif
       enddo
      close(minpfile)
      ! Check overlap of layer atoms
      call check_layeratoms(natwdummy,iout,nlay,layeratoms,natomslay)
      ! Check manually selected borders
      llg=.false.
      do ilay=2,nlay
       if(borderhand(ilay).ne.'auto') llg=.true.
      enddo
      if(llg) write(iout,'(a)') ' Checking manually selected borders...'
      do ilay=2,nlay
       if(borderhand(ilay).ne.'auto') then
        call manual_borderat(ilay,nlay,natoms,border(ilay),borderat,
     $layeratoms,natomslay,iout,ind,borderstat,borderhand,cscrk,cscrk)
        call manual_linkat(ilay,nlay,natoms,linkat(ilay),linksym,
     $iout,ind,borderstat,borderhand,cscrk,cscrk)
        call manual_linksd(ilay,nlay,natoms,linksd(ilay),linkdist,
     $iout,ind,borderstat,borderhand,cscrk,cscrk)
       endif
      enddo
      if(llg) write(iout,'(a)') ' All selections seem ok.'
      ! Set default basis and charge if they are not defined
      cscr4='none'
      write(iout,*) 'Checking charge specification of the layers...'
      do ilay=1,nlay
       if(ibas(ilay).eq.'none'.or.ibas(ilay).eq.' ') then
        do i=ilay+1,nlay
         if(ibas(i).ne.'none'.and.ibas(i).ne.' ') then
          ibas(ilay)=ibas(i)
          exit
         endif
        enddo
       endif
       if(cchg(ilay).eq.'    ') then
        write(iout,"( ' Warning! The charge of layer',i2,' is 
     $undetermined.')"),ilay
        cscr4='zero'
        ichg(ilay)=0
       else
        read(cchg(ilay),'(i4)') ichg(ilay)
       endif
      enddo
      ! Check for template files
      write(iout,*)
      if     (subminp.eq.'minp'.or.subminp.eq.'m+t') then
       write(iout,'(a)') ' Keywords specified in the MINP will be 
     $used for all calculations.'
      else if(subminp.eq.'top'.or.subminp.eq.'t+t') then
       write(iout,'(a)') ' Keywords specified in the MINP will be 
     $only used for the top layer calculations.'
      endif 
      if(subminp.eq.'temp'.or.
     $   subminp.eq.'t+t' .or.
     $   subminp.eq.'m+t') then
       usetemp=.true.
       write(iout,'(a)') ' Template files will be used for all 
     $calculations.'
       write(iout,'(a)') ' Checking for template files...'
       nsp=(nlay-1)*2+1 
       do isp=1,nsp
        write(cscr2,'(i2)') isp
        cscr16='MINP.'//trim(adjustl(cscr2))//'.tpl'
        inquire(file=cscr16,exist=llg)
        if(llg) write(iout,"( ' Template file for 
     $calculation #',a2,' is found: ',a16)") 
     $cscr2,trim(adjustl(cscr16))
       enddo
       write(iout,*)
      endif
      ! Print layer information
      call print_layers(natwdummy,iout,imet,ibas,ichg,imul,cchg,nlay,
     $layeratoms,natomslay,borderhand,minpfile)
      return
      end
C
C
************************************************************************
      subroutine oniomreadspec(natoms,iout,ind,cscrk,stringsize,
     $minpfile,imet,ibas,cchg,cmul,ilay,nlay,imul,borderhand,
     $border,linkat,linksd)
************************************************************************
* Read the requested layer specifications
************************************************************************
      implicit none
      integer natoms,stringsize,iout,minpfile,ilay,nlay,k,i
      integer ind(natoms+1),imul(nlay),bordersize,linksdsize
      character*4 cmul(nlay),cchg(nlay),borderhand(nlay)
      character*20 ibas(nlay)
      character*32 imet(nlay)
      character(len=natoms*4*8) border(nlay)
      character(len=natoms*3*8) linkat(nlay),linksd(nlay)
      character(len=8*natoms*8) cscrk
      bordersize=4*natoms*8
      linksdsize=3*natoms*8
      ! Read upper layer method/basis/charge/mult
      ! format: METHOD / BASIS / CHARGE / MULTIPLICITY 
      ! METHOD: defines keyword "calc"
      ! BASIS: defines keyword "basis"
      ! CHARGE: defines keyword "charge"
      ! MULTIPLICITY: defines keyword "mult"
      read(minpfile,'(a)') cscrk
      call lowercase(cscrk,cscrk,stringsize)
      ind=0
      cscrk=trim(adjustl(cscrk))
      call stringseparator(cscrk,stringsize,'/',1,ind,natoms+1,k,iout)
      if     (k.eq.0) then
       call stringfiller
     $(cscrk,stringsize,1,stringsize,imet(ilay-1),32)
      else if(k.eq.1) then
       call stringfiller
     $(cscrk,stringsize,1,ind(1)-1,imet(ilay-1),32)
       call stringfiller
     $(cscrk,stringsize,ind(1)+1,stringsize,ibas(ilay-1),20)
      else if(k.eq.2) then
       call stringfiller
     $(cscrk,stringsize,1,ind(1)-1,imet(ilay-1),32)
       call stringfiller
     $(cscrk,stringsize,ind(1)+1,ind(2)-1,ibas(ilay-1),20)
       call stringfiller
     $(cscrk,stringsize,ind(2)+1,stringsize,cchg(ilay-1),4)
      else if(k.eq.3) then
       call stringfiller
     $(cscrk,stringsize,1,ind(1)-1,imet(ilay-1),32)
       call stringfiller
     $(cscrk,stringsize,ind(1)+1,ind(2)-1,ibas(ilay-1),20)
       call stringfiller
     $(cscrk,stringsize,ind(2)+1,ind(3)-1,cchg(ilay-1),4)
       call stringfiller
     $(cscrk,stringsize,ind(3)+1,stringsize,cmul(ilay-1),4)
      endif
      imet(ilay-1)=trim(adjustl(imet(ilay-1)))
      ibas(ilay-1)=trim(adjustl(ibas(ilay-1)))
      cchg(ilay-1)=trim(adjustl(cchg(ilay-1)))
      cmul(ilay-1)=trim(adjustl(cmul(ilay-1)))
      if(imet(ilay-1).eq.' ') then
       write(iout,'(a)') ' The level of theory is not defined 
     $for an ONIOM layer.'
       call mrccend(1)
      endif
      if(cmul(ilay-1).ne.'    ') then
       read(cmul(ilay-1),'(i4)') imul(ilay-1)
      endif
      ! Read about handling of the layer boundaries
      ! format: <Q>/<B1>:<X1>-<Y1>,<B2>:<X2>-<Y2>,...,<BN>:<XN>-<YN> / <B1>:<L1>,<B2>:<L2>,...,<BN>:<LN> / <B1>:<R1>,<B2>:<R2>,...,<BN>:<RN>
      ! Q=0 - automatic boundary handling 
      ! Q=1 - semi-automatic boundary handling (use Q=0 but some options are overwritten manually)
      ! Q=2 - manual boundary handling
      ! B1,B2,...,BN - boundary number 1, 2,...,N
      ! X1,X2,...,XN - host atom of the upper layer of boundary 1, 2,..., N
      ! Y1,Y2,...,YN - host atom of the lower layer of boundary 1, 2,..., N
      ! L1,L2,...,LN - link atom of boundary 1, 2,...,N
      ! R1,R2,...,RN - link atom and upper layer host atom distance of of boundary 1, 2,...,N
      read(minpfile,'(a)') cscrk
      call lowercase(cscrk,cscrk,stringsize)
      ind=0
      cscrk=trim(adjustl(cscrk))
      call stringseparator(cscrk,stringsize,'/',1,ind,natoms+1,k,iout)
      if(k.gt.0) then
       call stringfiller
     $(cscrk,stringsize,1,ind(1)-1,borderhand(ilay),4)
      else
       call stringfiller
     $(cscrk,stringsize,1,stringsize,borderhand(ilay),4)
      endif
      borderhand(ilay)=trim(adjustl(borderhand(ilay)))
      if(borderhand(ilay).eq.'0') then
       borderhand(ilay)='auto'
      else if(borderhand(ilay).eq.'1') then
       borderhand(ilay)='semi'
      else if(borderhand(ilay).eq.'2') then
       borderhand(ilay)='manu'
      else
       write(iout,'(a)') 'Illegal specification of 
     $the handling of layer boundaries.'
       call mrccend(1)
      endif
      if(borderhand(ilay).ne.'auto') then
       if     (k.eq.1) then
        call stringfiller
     $(cscrk,stringsize,ind(1)+1,stringsize,border(ilay),bordersize)
       else if(k.eq.2) then
        call stringfiller
     $(cscrk,stringsize,ind(1)+1,ind(2)-1,border(ilay),bordersize)
        call stringfiller
     $(cscrk,stringsize,ind(2)+1,stringsize,linkat(ilay),linksdsize)
       else if(k.eq.3) then
        call stringfiller
     $(cscrk,stringsize,ind(1)+1,ind(2)-1,border(ilay),bordersize)
        call stringfiller
     $(cscrk,stringsize,ind(2)+1,ind(3)-1,linkat(ilay),linksdsize)
        call stringfiller
     $(cscrk,stringsize,ind(3)+1,stringsize,linksd(ilay),linksdsize)
       endif
      endif
      !write(6,'(2a)'),'cscrk = ',cscrk
      border(ilay)=trim(adjustl(border(ilay)))
      linkat(ilay)=trim(adjustl(linkat(ilay)))
      linksd(ilay)=trim(adjustl(linksd(ilay)))
!      print*,'ilay = ',ilay
!      print*,'border(ilay) = ',trim(adjustl(border(ilay)))
!      print*,'linkat(ilay) = ',trim(adjustl(linkat(ilay)))
!      print*,'linksd(ilay) = ',trim(adjustl(linksd(ilay)))
      return
      end
C
************************************************************************
      subroutine oniomat(natoms,minpfile,ind,iout)
************************************************************************
* Read atoms of the oniom layers
************************************************************************
      implicit none
      integer natoms,m,n,minpfile,iout,i,ii,jj,ind(natoms+1)
      character*1 line2(16),line3(max(512,6*natoms))
      character*16 line1
      equivalence(line1,line2)
      n=0
      line3=' '
      do
       n=n+1
       read(minpfile,'(a)',advance='no',eor=1234,end=1234) line3(n)
      enddo
1234  continue
      n=1
      ind=0
       do while(line3(n).ne.' ')
        m=n
         do while(line3(n).ne.','.and.line3(n).ne.'-'
     $.and.line3(n).ne.' ')
          n=n+1
         enddo
        line1='                '
         do i=m,n-1
          line2(i-m+1)=line3(i)
         enddo
        read(line1,*) ii
        jj=ii
         if(line3(n).eq.'-') then
          n=n+1
          m=n
           do while(line3(n).ne.','.and.line3(n).ne.' ')
            n=n+1
           enddo
          line1='                '
           do i=m,n-1
            line2(i-m+1)=line3(i)
           enddo
          read(line1,*) jj
         endif
         if(jj.gt.natoms) then
          write(iout,*) 'Invalid ONIOM-layer specification!'
          call mrccend(1)
         endif
        ind(ii:jj)=1
        n=n+1
       enddo
C
      return
      end
C
************************************************************************
      subroutine check_layeratoms(natoms,iout,nlay,layeratoms,natomslay)
************************************************************************
* Check if the upper layer atoms are subset of the lower layer
************************************************************************
      implicit none
      integer natoms,nlay,ilay,jlay,iatom,jatom,i,iout
      integer layeratoms(natoms,nlay),natomslay(nlay)
      logical ll
      ilay=nlay
      do i=1,nlay
       do jlay=1,ilay-1
        do iatom=1,natomslay(ilay)
         ll=.false.
         do jatom=1,natomslay(jlay)
          if(layeratoms(iatom,ilay).eq.layeratoms(jatom,jlay)) ll=.true.
         enddo
         if(ll.eqv..false.) then
          write(iout,'(a)') 'Illegal specification of layer atoms.' 
          write(iout,'(a)') 'Inner layer atoms must be a subset of the 
     $outer layer atoms.'
          call mrccend(1)
         endif
        enddo
       enddo
       ilay=ilay-1
      enddo
      return
      end
C
************************************************************************
      subroutine get_coords(qmmm,minpfile,scrfile1,natoms,natwdummy,
     $iout,coord,atchg,atsymbol,angtobohr,uval,ncent)
************************************************************************
* Check if the upper layer atoms are subset of the lower layer
************************************************************************
       integer minpfile,scrfile1,icharge,imult,natwdummy,iatoms,ncent
       integer natoms,j,atnum(natwdummy),iout,n,i,nelec,ncore
       character*1 ch1
       character*2 atsymbol(natwdummy)
       character*4 gval,uval
       character*8 cscr8,qmmm
       character*20 bfbasis
       real*8 coord(3,ncent),atchg(ncent),angtobohr
      open(minpfile,file='MINP')
       call getkey('bfbasis',7,bfbasis,20)
       call getkey('unit',4,uval,4)
       if(uval.ne.'bohr'.and.uval.ne.'angs'.and.uval.ne.'    ')
     $call unknown('unit',4)
       if(uval.eq.'    ') uval='angs'
       call getkeym('geom',4,gval,4)
C Read Cartesian coordinates in the case of QM/MM calculation
       if(qmmm.eq.'charmm  ') then
        open(scrfile1,file='q1.inp')
        cscr8='        '
         do while(cscr8.ne.'$molecul')
          read(scrfile1,"(a8)") cscr8
         enddo
        read(scrfile1,*) icharge,imult
         do iatoms=1,natoms
          atnum(iatoms)=0
          read(scrfile1,*) atsymbol(iatoms),(coord(j,iatoms),j=1,3)
         enddo
        rewind(scrfile1)
        cscr8='        '
         do while(cscr8.ne.'$externa')
          read(scrfile1,"(a8)") cscr8
         enddo
         do iatoms=natoms+1,natwdummy
          read(scrfile1,*) (coord(j,iatoms),j=1,3),atchg(iatoms)
         enddo
        close(scrfile1)
C Construct Z-matrix
       else if(gval.eq.'zmat'.or.gval.eq.'    ') then
        call zmattocart(coord,natwdummy,atsymbol)
         do iatoms=1,natoms
          atnum(iatoms)=0
         enddo
       else
C Read Cartesian coordinates
        write(iout,*)
        read(minpfile,*)
         if(gval.ne.'mol ') read(minpfile,*)
         if(gval.eq.'xyz ') then !xyz format
          read(minpfile,*) ch1
          backspace(minpfile)
          i=ichar(ch1)
          do iatoms=1,natoms
           atnum(iatoms)=0
           read(minpfile,*) atsymbol(iatoms),(coord(j,iatoms),j=1,3)
          enddo
         else !Turbomole and mol format
          read(minpfile,*) sum,sum,sum,ch1
          backspace(minpfile)
          i=ichar(ch1)
          n=natoms
           if(bfbasis.ne.'none                ') n=n-nbondc
           if(i.ge.49.and.i.le.57) then
             do iatoms=1,n
              read(minpfile,*) (coord(j,iatoms),j=1,3),atnum(iatoms)
             enddo
           else
             do iatoms=1,n
              atnum(iatoms)=0
              read(minpfile,*) (coord(j,iatoms),j=1,3),atsymbol(iatoms)
             enddo
           endif
           if(bfbasis.ne.'none                ') then
             do iatoms=n+1,natoms
              atnum(iatoms)=0
              atsymbol(iatoms)='Bf'
             enddo
           endif
         endif
       endif
C Read point charges in the case Amber interface
       if(qmmm.eq.'amber   ') then
        rewind(minpfile)
        cscr8='        '
         do while(cscr8.ne.'pointcha')
          read(minpfile,"(a8)") cscr8
         enddo
         read(minpfile,*) i
         do iatoms=natoms+1,ncent
          read(minpfile,*) (coord(j,iatoms),j=1,3),atchg(iatoms)
         enddo
       endif
      close(minpfile)
      return
      end
C
************************************************************************
      subroutine print_layers(natoms,iout,imet,ibas,ichg,imul,cchg,nlay,
     $layeratoms,natomslay,borderhand,scrfile1) 
************************************************************************
* Print layer information: layer number, atoms of the layer, method
* basis, charge, and multiplicity
************************************************************************
      implicit none
      integer natoms,i,k,ilay,nlay,iout,ichg(nlay),imul(nlay)
      integer natomslay(nlay),layeratoms(natoms,nlay),level
      integer isp,nsp,scrfile1
      character*4 cscr4,cchg(nlay),borderhand(nlay)
      character*8 oniom,cscr8
      character*32 imet(nlay)
      character*20 ibas(nlay)
      character*40 cscr40
      write(iout,'(a)') ' ============================================
     $=========================='
      write(iout,'(a)') ' ***                    Layer specifications   
     $                     ***'
      write(iout,'(a)') ' ============================================
     $=========================='
      write(iout,*)
      do ilay=1,nlay
       write(iout,'(a,i2)') ' Layer:               ',ilay
       write(iout,'(a,i6)') ' Number of atoms: ',natomslay(ilay)
       write(iout,'(a)')    ' Atoms of the layer:     '
       write(iout,'(14i6)') (layeratoms(k,ilay),k=1,natomslay(ilay))
       write(iout,'(a,a)')  ' Method:      ',
     $trim(adjustl(imet(ilay)))
       write(iout,'(a,a)')  ' Basis set:   ',
     $trim(adjustl(ibas(ilay)))
       write(iout,'(a,i6)')  ' Charge:     ',ichg(ilay)
       if(imul(ilay).ne.0) then
        write(iout,'(a,i2)')  ' Multiplicity:   ',imul(ilay)
       else
        write(iout,'(a)')  ' Multiplicity:   to be determined'
       endif
       if(borderhand(ilay).eq.'auto') then
        write(iout,'(a)')  ' Boundary handling: automatic'
       else if(borderhand(ilay).eq.'semi') then
        write(iout,'(a)')  ' Boundary handling: semi-automatic'
       else if(borderhand(ilay).eq.'manu') then
        write(iout,'(a)')  ' Boundary handling: manual'
       endif
       write(iout,*)
      enddo
      nsp=(nlay-1)*2+1
      ilay=1
      level=0
      write(iout,'(a)') ' Single point calculations will be executed 
     $in the following order:'
      write(iout,'(a)') ' Calc. number   Layer number   
     $   Level'
      do isp=1,nsp ! Main loop starts
       if(MOD(isp,2).eq.0) then
        ilay=ilay+1
       else
        level=level+1
       endif
       cscr40=trim(adjustl(imet(level)))//'/'//
     $trim(adjustl(ibas(level)))
       write(iout,"(4x,i4,10x,i4,9x,a40)")
     $isp, ilay,cscr40
      enddo
      return
      end
C
************************************************************************
      subroutine write_minp(qmmm,dens,isp,minpfile,natoms,natwdummy,
     $ncent,coord,atsymbol,atchg,method,basis,charge,mult,iout,mem,geom,
     $usetemp,verbosity,uval,nkeys,keywstring,kstringsize,mpitasks,pcm,
     $pcmkeystring,npcmdefkeys,oniomtype,ccoord,ncharge)
************************************************************************
* write MINP file for each ONIOM calculation
************************************************************************
      implicit none
      integer ncent,natoms,isp,i,j,iout,minpfile,iatoms,k,ncharge
      integer charge,mult,natwdummy,ierr,nkeys,kstringsize,npcmdefkeys
      character(len=kstringsize) keywstring
      character*1 line1(512)
      character*2 atsymbol(natwdummy),cscr2
      character*4 verbosity,dens,geom,uval,mpitasks,oniomtype
      character*8 qmmm,cscr8
      character*16 mem,cscr16,inpfile
      character*32 method,pcm
      character*20 basis
      character*512 line,pcmkeystring
      real*8 coord(3,ncent),atchg(ncent),ccoord(3,ncent)
      logical usetemp,llg
      equivalence(line,line1)
      write(iout,'(a)') ' Writing MINP file ...'
      write(cscr2,'(i2)') isp
      ! Search for template file
      inpfile='MINP.'//trim(adjustl(cscr2))
      cscr16='MINP.'//trim(adjustl(cscr2))//'.tpl'
      if(usetemp) then
       inquire(file=cscr16,exist=llg) 
       if(llg) then
        write(iout,"( ' Template file is found. Using file: 
     $',a12)") cscr16
#ifdef WINTEL
        call execute_command_line('echo ! User defined ke'
     $ //'ywords from MINP template file >' //inpfile)
        call execute_command_line('cat '//cscr16//' >> '//inpfile)
#else
        call system('echo "! User defined keywords from MINP 
     $template file" >'//inpfile//'; cat '//cscr16//' >> '//inpfile)
#endif
        open(minpfile, file=inpfile, iostat=ierr, position='append')
       else
        write(iout,"( ' Template file is not found.')")
        open(minpfile, file=inpfile, iostat=ierr, status='replace') 
       endif
      else      
       open(minpfile, file=inpfile, iostat=ierr, status='replace') 
      endif
      write(minpfile,'(a)')'! User defined keywords from MINP' 
!      write(minpfile,'(a,a)')'mem=',mrcc_nml%mem
      write(minpfile,'(a,a)')'calc=',trim(adjustl(method))
      write(minpfile,'(a,a)')'basis=',trim(adjustl(basis))
      write(minpfile,'(2a)')'verbosity=',trim(adjustl(verbosity))
      write(cscr8,'(i5)') charge
      write(minpfile,'(2a)')'charge=',trim(adjustl(cscr8))
      if(mult.ne.0) then
       write(cscr8,'(i5)') mult
       write(minpfile,'(2a)')'mult=',trim(adjustl(cscr8))
      endif
      if(nkeys.ne.0) then
       do i=1,nkeys
        if(i.eq.1) then
         read(keywstring,*) line
        else
         read(keywstring,*) (line1(k),k=1,i-1),line
        endif
        write(minpfile,'(a)') trim(adjustl(line))
       enddo
      endif
      write(minpfile,'(a)')'! Default keywords for ONIOM calculation'
      write(minpfile,'(2a)')'mpitasks=',trim(adjustl(mpitasks))
      write(minpfile,'(2a)')'unit=',trim(adjustl(uval))
      write(minpfile,'(2a)')'mem=',trim(adjustl(mem))
      if(trim(adjustl(pcm)).ne.'off') then
       write(minpfile,'(2a)')'pcm=',trim(adjustl(pcm))
       if(npcmdefkeys.ne.0) then
        do i=1,npcmdefkeys
        if(i.eq.1) then
         read(pcmkeystring,*) line
        else
         read(pcmkeystring,*) (line1(k),k=1,i-1),line
        endif
        write(minpfile,'(a)') trim(adjustl(line))
       enddo
       endif
      endif
      if(qmmm.eq.'amber') then
       write(minpfile,'(a)')'qmmm=amber'
      endif
      write(minpfile,'(2a)')'dens=',trim(adjustl(dens))
      write(minpfile,*)
      write(minpfile,'(a)') 'geom=xyz'
      write(cscr16,'(i16)') natoms
      write(minpfile,'(a)') trim(adjustl(cscr16))
      write(minpfile,*)
      do iatoms=1,natoms
       write(minpfile,'(a2,3f25.16)') 
     $atsymbol(iatoms),coord(1:3,iatoms)
      enddo
      write(minpfile,*)
      if(qmmm.eq.'amber'.or.oniomtype.eq.'ee') then
       write(minpfile,'(a)') 'pointcharges'
       write(cscr16,'(i16)') ncharge
       write(minpfile,'(a)') trim(adjustl(cscr16))
       do iatoms=1,ncharge
        write(minpfile,'(4f25.16)') ccoord(1:3,iatoms),atchg(iatoms)
       enddo
      endif
      close(minpfile)
      return
      end
C
************************************************************************
      subroutine modify_mem(oldmem,mem,imemdiff,cmemdiff,iout)
************************************************************************
* Redefine the requested memory to incorporate the ONIOM memory requirement
************************************************************************
      integer imemdiff,imem,iout
      integer i,imem1,intadd
      real*8 roldmem,rmem
      character*1 line2(16)
      character*2 ch2
      character*16 line1,oldmem,mem,cscr16,cmemdiff
      equivalence(line1,line2)
C 
      line1=oldmem
      if(line1.ne.'                ') then
       i=1
       do while(line2(i).ne.' '.and.i.lt.16)
        i=i+1
       enddo
       call lowercase(line2(i-2),ch2,2)
       if(ch2.ne.'mb'.and.ch2.ne.'gb') then
        write(iout,*) 'Unknown memory unit!'
        call exit(1)
       endif
       line2(i-2)=' '
       line2(i-1)=' '
       read(line1,*) roldmem
      else
       ch2='mb'
       roldmem=256.d0
      endif
      if(ch2.eq.'gb') roldmem=1024.d0*roldmem
      rmem=roldmem-imemdiff*8d0/1024d0/1024d0
      imem=int(rmem)
      write(cscr16, '(i14)') imem
      line1=trim(adjustl(cscr16))
      i=1
      do while(line2(i).ne.' '.and.i.lt.16)
       i=i+1
      enddo
      line2(i)='m'
      line2(i+1)='b'
      mem=line1
      rmem=imemdiff*8d0/1024d0/1024d0
      imem=int(rmem)
      if(imem.eq.0) imem=1
      write(cscr16, '(i14)') imem
      line1=trim(adjustl(cscr16))
      i=1
      do while(line2(i).ne.' '.and.i.lt.16)
       i=i+1
      enddo
      line2(i)='m'
      line2(i+1)='b'
      cmemdiff=line1
!      print*,'oldmem =',trim(adjustl(oldmem)),
!     $'mem = ',mem,' memdiff = ',cmemdiff
      return
      end
C
************************************************************************
      subroutine search_layerborders(nlay,natoms,natwdummy,scrfile1,
     $natomslay,layeratoms,nborders,borderat,bondord,iout,
     $atsymbol,linksym,borderhand,borderstat)
************************************************************************
* Search for those bonds that connect the different layers
************************************************************************
      implicit none
      integer nlay,natoms,natwdummy,minpfile,scrfile1,ilay,iout,n
      integer natomslay(nlay),layeratoms(natoms,nlay),k,l,i
      integer borderat(2,natoms,nlay),nborders(nlay)
      integer ibonds,nbonds,j,iatoms,jatoms,ind(natoms+1)
      integer ispec,bondord(natoms,nlay)
      character*1 borderstat(natoms,nlay)
      character*2 cscr2i,cscr2j
      character*2 atsymbol(natwdummy),linksym(natoms,nlay)
      character*4 borderhand(nlay)
      real*8 rscr
      logical ii,jj,kk
      nborders=0
      ind=0
      write(iout,*)
      write(iout,'(a)') ' Searching for boundaries of the layers...' 
      open(scrfile1,file='BONDTABLE',position='append') 
       backspace(scrfile1)
       read(scrfile1,'(i5)') nbonds
       rewind(scrfile1)
       read(scrfile1,*)
       do ibonds=1,nbonds
        iatoms=0
        jatoms=0
        read(scrfile1,*) i,i
        if(i.eq.2) then
         backspace(scrfile1)
         read(scrfile1,*) i,i,rscr,iatoms,jatoms
        endif
        do ilay=2,nlay
         if(borderhand(ilay).ne.'manu') then
          ii=.false.
          jj=.false.
          kk=.false.
          do k=1,natomslay(ilay)
           if(iatoms.eq.layeratoms(k,ilay)) ii=.true.
           if(jatoms.eq.layeratoms(k,ilay)) jj=.true.
          enddo
          ! increment bond order if the border is already found
          if(ii.neqv.jj.and.rscr.gt.0.8d0) then ! 
           do k=1,nborders(ilay)
            if((borderat(1,k,ilay).eq.iatoms.and.
     $          borderat(2,k,ilay).eq.jatoms).or.
     $         (borderat(1,k,ilay).eq.jatoms.and.
     $         borderat(2,k,ilay).eq.iatoms)) then
             bondord(k,ilay)=bondord(k,ilay)+1
             kk=.true.
             exit
            endif
           enddo
           ! new border is found
           if(kk.eqv..false.) then
            nborders(ilay)=nborders(ilay)+1
            if(ii) then
             borderat(1,nborders(ilay),ilay)=iatoms
             borderat(2,nborders(ilay),ilay)=jatoms
            endif
            if(jj) then
             borderat(1,nborders(ilay),ilay)=jatoms
             borderat(2,nborders(ilay),ilay)=iatoms
            endif
            if(borderstat(nborders(ilay),ilay).eq.' ') then
             borderstat(nborders(ilay),ilay)='A'
            endif
            bondord(nborders(ilay),ilay)=1
           endif
          endif
         endif
        enddo
       enddo
       ! Set the type of link atom in the case of automatic selections
       do ilay=2,nlay
        do k=1,nborders(ilay)
         if(borderstat(k,ilay).eq.'A') then
          if(bondord(k,ilay).ge.2) then
           write(iout,"(' Warning! Multiple MOs are localized to 
     $layer ',i2,', boundary ',i2)") ilay,k
          endif
          if(bondord(k,ilay).eq.1) linksym(k,ilay)='H '
          if(bondord(k,ilay).eq.2) linksym(k,ilay)='O '
          if(bondord(k,ilay).eq.3) linksym(k,ilay)='N '
          if(bondord(k,ilay).ge.4) then
           write(iout,'(a)') ' Quadruple bond is detected at the 
     $boundary border.'
           write(iout,'(a)') ' Something must have gone wrong.'
           call mrccend(1)
          endif
         endif
        enddo
       enddo
       ! Modify the number of borders by the used defined borders
       do ilay=2,nlay
        if(borderhand(ilay).eq.'manu') then
         do j=1,natoms
          if(borderstat(j,ilay).eq.'M') nborders(ilay)=nborders(ilay)+1
         enddo
        endif
        if(borderhand(ilay).eq.'semi') then
         do j=1,natoms
          if(borderstat(j,ilay).eq.'M') nborders(ilay)=nborders(ilay)+1
          if(borderstat(j,ilay).eq.'D') nborders(ilay)=nborders(ilay)-1
         enddo
        endif
       enddo
c       if(llg) then
c        write(iout,"(' This can lead to unexpected errors.')")
c        write(iout,"(' Please reconsider your layer specification.')")
c       endif
      close(scrfile1)
      write(iout,'(a)') ' Done.'
      return
      end
C
************************************************************************
      subroutine print_layerborders(nlay,natoms,natwdummy,scrfile1,
     $natomslay,layeratoms,nborders,borderat,
     $bondord,iout,atsymbol,linksym,borderhand,linkdist,
     $borderstat,uval,linkcoord,nlinks)
************************************************************************
* Print border atoms, link atoms, and handling
************************************************************************
      implicit none
      integer nlay,natoms,natwdummy,minpfile,scrfile1,ilay,iout,n
      integer natomslay(nlay),layeratoms(natoms,nlay),k,l,i
      integer borderat(2,natoms,nlay),nborders(nlay)
      integer ibonds,nbonds,j,iatoms,jatoms
      integer ispec,nlinks(nlay),bondord(natoms,nlay)
      character*1 borderstat(natoms,nlay)
      character*2 atsymbol(natwdummy),linksym(natoms,nlay)
      character*4 borderhand(nlay),uval
      real*8 linkdist(natoms,nlay)
      real*8 linkcoord(3,natoms,nlay)
      logical ii,jj
      write(iout,*)
      write(iout,'(a)') ' ########################################'
      write(iout,'(a)') ' ***       Boundary information       ***'
      write(iout,'(a)') ' ########################################'
      write(iout,*)
      write(iout,'(a)') ' ---------------------------------------'
      do ilay=2,nlay
       write(iout,"(     '             Layer: ',i2,'            ')") 
     $ilay
       if(borderhand(ilay).eq.'auto') then
        write(iout,'(a)') ' Boundary handling:    automatic'
       else if(borderhand(ilay).eq.'semi') then
        write(iout,'(a)') ' Boundary handling:    semi-automatic'
       else if(borderhand(ilay).eq.'manu') then
        write(iout,'(a)') ' Boundary handling:    manual'
       endif
       if(nborders(ilay).gt.0) then
        write(iout,"(' Number of boundaries: ',i2)") nborders(ilay)
        write(iout,*)
        k=0
        do j=1,natoms
         if(borderstat(j,ilay).ne.' ') then
          write(iout,"(' Boundary No.:          ',i2)") j
          if(borderhand(ilay).eq.'semi') then
           if(borderstat(j,ilay).eq.'A') then
            write(iout,"(' Selection scheme:      automatic')")
           else if(borderstat(j,ilay).eq.'D') then
            write(iout,"(' Selection scheme:      manual 
     $(deleted border)')")
           else if(borderstat(j,ilay).eq.'M') then
            write(iout,"(' Selection scheme:      manual')")
           endif
          endif
          call uppercase(atsymbol(borderat(1,j,ilay)),
     $                   atsymbol(borderat(1,j,ilay)),1)
          call uppercase(atsymbol(borderat(2,j,ilay)),
     $                   atsymbol(borderat(2,j,ilay)),1)
          if(borderstat(j,ilay).ne.'D') then
           write(iout,"(' Layer atom:     ',i8,' ',a2)") 
     $borderat(1,j,ilay),atsymbol(borderat(1,j,ilay)) 
           write(iout,"(' Non-layer atom: ',i8,' ',a2)") 
     $borderat(2,j,ilay),atsymbol(borderat(2,j,ilay))
           if(borderstat(j,ilay).eq.'A') then
c            write(iout,"(' Mayer bond order:   ',f10.5)") 
c     $bondord(j,ilay)
            write(iout,"(' # of LMOs:      ',i8)") 
     $bondord(j,ilay)
           endif
           write(iout,"(' Link atom:             ',a2)")linksym(j,ilay)
           if(uval.eq.'    '.or.uval.eq.'angs') then
            write(iout,"(' Link atom distance: ',f10.5,' Angstrom')")
     $linkdist(j,ilay)
           else
            write(iout,"(' Link atom distance: ',f10.5,' Bohr')")
     $linkdist(j,ilay)
           endif
           k=k+1
           ! Reorder manually selected borders
           if(((borderstat(j,ilay).eq.'M').or.
     $         (borderstat(j,ilay).eq.'A')).and.
     $         (k.ne.j)) then
            borderstat(k,ilay)=borderstat(j,ilay)
            borderstat(j,ilay)=' '
            borderat(1,k,ilay)=borderat(1,j,ilay)
            borderat(2,k,ilay)=borderat(2,j,ilay)
            borderat(1,j,ilay)=-1
            borderat(2,j,ilay)=-1
            linksym(k,ilay)=linksym(j,ilay)
            linksym(j,ilay)='  '
            linkdist(k,ilay)=linkdist(j,ilay)
            linkdist(j,ilay)=0.0d0
           endif
           write(iout,"(' Link atom coordinates: 
     $x = ',f10.5,' y = ',f10.5,' z = ',f10.5)") 
     $linkcoord(1,k,ilay),linkcoord(2,k,ilay),linkcoord(3,k,ilay)
           write(iout,*)
          else
           write(iout,"(' Layer atom:     ',i8,' ',a2)")
     $borderat(1,j,ilay),atsymbol(borderat(1,j,ilay))
           write(iout,"(' Non-layer atom: ',i8,' ',a2)")
     $borderat(2,j,ilay),atsymbol(borderat(2,j,ilay))
           write(iout,*)
          endif
         endif 
        enddo
       else 
        write(iout,'(a)') ' The layers are not connected covalently.'
        write(iout,'(a)') ' Boundary handling is not required.'
       endif
       write(iout,'(a)') ' ---------------------------------------'
      enddo
      write(iout,'(a)') ' #######################################'
      return
      end
C
************************************************************************
      subroutine write_oniomspec(scrfile1,nlay,nborders,borderstat,
     $borderat,linksym,linkdist,natoms,eecharge,natomslay,layeratoms,
     $imet,ibas,ichg,imul,borderhand,nkeys,keywstring,npcmdefkeys,
     $pcmkeystring,kstringlen,pcmstringlen)
************************************************************************
* Save ONIOM specifications 
************************************************************************
      implicit none
      integer           :: scrfile1,ilay,nlay,natoms,j,k,nkeys
      integer           :: kstringlen,pcmstringlen,npcmdefkeys
      integer           :: nborders(nlay),natomslay(nlay)
      integer           :: borderat(2,natoms,nlay)
      integer           :: layeratoms(natoms,nlay)
      integer           :: ichg(nlay),imul(nlay)
      real*8            :: linkdist(natoms,nlay),eecharge(natoms)
      character(len=1)  :: borderstat(natoms,nlay)
      character(len=2)  :: linksym(natoms,nlay)
      character(len=4)  :: borderhand(nlay)
      character(len=32) :: imet(nlay)
      character(len=20) :: ibas(nlay)
      character(len=kstringlen)   :: keywstring
      character(len=pcmstringlen) :: pcmkeystring
      ! write layer/method settings
      open(scrfile1,file='ONIOMSPEC',form='UNFORMATTED')
       write(scrfile1) 'LAYERSPEC'
       write(scrfile1) nlay
       do ilay=1,nlay
        write(scrfile1) natomslay(ilay)
        write(scrfile1) (layeratoms(k,ilay),k=1,natomslay(ilay))
        write(scrfile1) imet(ilay),ibas(ilay),ichg(ilay),imul(ilay),
     $borderhand(ilay)
       enddo
       ! write filtered keywords
       write(scrfile1) 'KEYS'
       write(scrfile1) nkeys,keywstring
       write(scrfile1) npcmdefkeys,pcmkeystring
       ! write border settings
       write(scrfile1) 'ONIOMBORDER'
       do ilay=2,nlay
        write(scrfile1) nborders(ilay)
        do j=1,nborders(ilay)
          write(scrfile1) j
          write(scrfile1) borderstat(j,ilay),
     $borderat(1,j,ilay),borderat(2,j,ilay),
     $linksym(j,ilay),linkdist(j,ilay)
        enddo
       enddo
       ! write point charges in the case of electronic embedding
       write(scrfile1) 'CHARGES'
       write(scrfile1) natoms
       write(scrfile1) (eecharge(j),j=1,natoms)
      close(scrfile1)
      return
      end
C
************************************************************************
      subroutine manual_borderat(ilay,nlay,natoms,border,borderat,
     $layeratoms,natomslay,iout,separ,borderstat,borderhand,line3,line4)
************************************************************************
* Set used-defined border atoms
************************************************************************
      implicit none
      integer nlay,natoms,ilay,iout,n,startc
      integer natomslay(nlay),layeratoms(natoms,nlay),k,l,i
      integer borderat(2,natoms,nlay),separ(0:natoms),nsepar
      integer j,iatoms,jatoms,ispec,stringsize,maxelement
      character*1 c1,borderstat(natoms,nlay)
      character*4 borderhand(nlay)
      character*16 cscr16
      character(len=1) line3(4*natoms*8)
      character(len=natoms*4*8) line4
      character(len=natoms*4*8) border
      logical ii,jj,llg
      stringsize=natoms*4*8
      ! locate the separators
      separ=0
      call stringseparator(border,stringsize,',',1,separ(1),natoms+1,
     $nsepar,iout)
      if(border.ne.' ') then
       line4=border
       separ(0)=1
       separ(nsepar+1)=stringsize
       do i=0,nsepar
        if(i.eq.0) then
         n=separ(i)
        else
         n=separ(i)+1
        endif
        ii=.true.
        do k=1,3
         startc=n
         if(k.eq.1) c1=':'
         if(k.eq.2) c1='-'
         if(k.eq.3.and.i.eq.nsepar) then
          c1=' '
         else if(k.eq.3.and.i.ne.nsepar) then
          c1=','
         endif
         do while(line3(n).ne.c1.and.n.ne.stringsize
     $            .and.n.ne.separ(i+1))
          n=n+1
         enddo
         cscr16=' ' 
         call stringfiller(line4,stringsize,startc,n-1,
     $cscr16,16) 
         call lowercase(cscr16,cscr16,16)
         cscr16=trim(adjustl(cscr16))
         if(k.eq.1) read(cscr16,*) ispec
         if(k.eq.2) then
          if(cscr16.ne.'x') then
           read(cscr16,*) iatoms
          else
           write(iout,"(' Manually deleted boundary 
     $is detected. Boundary: 'i2,' Layer: ',i2)")ispec,ilay
           if(borderhand(ilay).eq.'semi') borderstat(ispec,ilay)='D'
           ii=.false.
           borderat(1,ispec,ilay)=0
           borderat(2,ispec,ilay)=0
          endif
         endif
         if(k.eq.3.and.ii) read(cscr16,*) jatoms
         n=n+1
        enddo
        if(ii) then
         ! place border atoms in place: 1: layer atom, 2:  non-layer atom
         ii=.false.
         jj=.false.
         do n=1,natomslay(ilay)
          if(layeratoms(n,ilay).eq.iatoms) ii=.true.
          if(layeratoms(n,ilay).eq.jatoms) jj=.true.
         enddo
         if(ii.neqv.jj) then
          if(ii) then
           borderat(1,ispec,ilay)=iatoms
           borderat(2,ispec,ilay)=jatoms
          endif
          if(jj) then
           borderat(1,ispec,ilay)=jatoms
           borderat(2,ispec,ilay)=iatoms
          endif
          write(iout,"(' Manually selected boundary atoms 
     $are detected. Boundary: 'i2,' Layer: ',i2)")ispec,ilay
          if(borderhand(ilay).ne.'auto') borderstat(ispec,ilay)='M'
         else
          write(iout,'(a)') ' Illegal specification of border atoms.'
          call mrccend(1)
         endif
        endif 
       enddo
      endif
      return
      end
************************************************************************
      subroutine manual_linkat(ilay,nlay,natoms,linkat,linksym,
     $iout,separ,borderstat,borderhand,line3,line4)
************************************************************************
* Set used-defined link atom types
************************************************************************
      implicit none
      integer nlay,natoms,ilay,iout,n,startc,k,l,i
      integer separ(0:natoms),nsepar
      integer j,ispec,stringsize,maxelement
      character*1 c1,borderstat(natoms,nlay)
      character*2 linksym(natoms,nlay),atsym(1:118)
      character*4 borderhand(nlay)
      character*16 cscr16
      character(len=1) line3(3*natoms*8)
      character(len=natoms*3*8) line4
      character(len=natoms*3*8) linkat
      logical ii,jj,llg
      data atsym /
     $            'H ','He','Li','Be','B ','C ','N ','O ','F ','Ne',
     $            'Na','Mg','Al','Si','P ','S ','Cl','Ar','K ','Ca',
     $            'Sc','Ti','V ','Cr','Mn','Fe','Co','Ni','Cu','Zn',
     $            'Ga','Ge','As','Se','Br','Kr','Rb','Sr','Y ','Zr',
     $            'Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd','In','Sn',
     $            'Sb','Te','I ','Xe','Cs','Ba','La','Ce','Pr','Nd',
     $            'Pm','Sm','Eu','Gd','Tb','Dy','Ho','Er','Tm','Yb',
     $            'Lu','Hf','Ta','W ','Re','Os','Ir','Pt','Au','Hg',
     $            'Tl','Pb','Bi','Po','At','Rn','Fr','Ra','Ac','Th',
     $            'Pa','U ','Np','Pu','Am','Cm','Bk','Cf','Es','Fm',
     $            'Md','No','Lr','Rf','Db','Sg','Bh','Hs','Mt','Ds',
     $            'Rg','Cn','Nh','Fl','Mc','Lv','Ts','Og'/
      stringsize=natoms*3*8
      ! locate the separators
      separ=0
      call stringseparator(linkat,stringsize,',',1,separ(1),natoms+1,
     $nsepar,iout)
      if(linkat.ne.' ') then
       line4=linkat
       separ(0)=1
       separ(nsepar+1)=stringsize
       do i=0,nsepar
        if(i.eq.0) then
         n=separ(i)
        else
         n=separ(i)+1
        endif
        do k=1,2
         startc=n
         if(k.eq.1) c1=':'
         if(k.eq.2.and.i.eq.nsepar) then
          c1=' '
         else if(k.eq.2.and.i.ne.nsepar) then
          c1=','
         endif
         do while(line3(n).ne.c1.and.n.ne.stringsize
     $            .and.n.ne.separ(i+1))
          n=n+1
         enddo
         cscr16=' ' 
         call stringfiller(line4,stringsize,startc,n-1,
     $cscr16,16) 
         call lowercase(cscr16,cscr16,16)
         cscr16=trim(adjustl(cscr16))
         if(k.eq.1) read(cscr16,*) ispec
         if(k.eq.2) linksym(ispec,ilay)=trim(adjustl(cscr16)) 
         n=n+1
        enddo
        call uppercase(linksym(ispec,ilay),linksym(ispec,ilay),1) 
        ii=.true.
        do k=1,118
         if(linksym(ispec,ilay).eq.atsym(k)) ii=.false.
        enddo
        if(ii) then
         write(iout,'(a)') ' Illegal specification of link atom type.'
         write(iout,"('Layer: ',i2,', Border: ',i4,' 
     $, Link atom type: ',a2)") ilay,ispec,linksym(ispec,ilay) 
         call mrccend(1)
        else
         write(iout,"(' Manually selected link atom 
     $is detected. Boundary: 'i2,' Layer: ',i2)")ispec,ilay
         if(borderhand(ilay).ne.'auto') borderstat(ispec,ilay)='M'
        endif
       enddo
      endif
      return
      end
C
************************************************************************
      subroutine manual_linksd(ilay,nlay,natoms,linksd,linkdist,
     $iout,separ,borderstat,borderhand,line3,line4)
************************************************************************
* Set used-defined link atom types
************************************************************************
      implicit none
      integer nlay,natoms,ilay,iout,n,startc,k,l,i
      integer separ(0:natoms),nsepar
      integer j,ispec,stringsize,maxelement
      character*1 c1,borderstat(natoms,nlay)
      character*2 atsym(1:118)
      character*4 borderhand(nlay)
      character*16 cscr16
      real*8 linkdist(natoms,nlay)
      logical ii,jj,llg
      character(len=1) line3(3*natoms*8)
      character(len=natoms*3*8) line4
      character(len=natoms*3*8) linksd
      stringsize=natoms*3*8
      ! locate the separators
      separ=0
      call stringseparator(linksd,stringsize,',',1,separ(1),natoms+1,
     $nsepar,iout)
      if(linksd.ne.' ') then
       line4=linksd
       separ(0)=1
       separ(nsepar+1)=stringsize
       do i=0,nsepar
        if(i.eq.0) then
         n=separ(i)
        else
         n=separ(i)+1
        endif
        do k=1,2
         startc=n
         if(k.eq.1) c1=':'
         if(k.eq.2.and.i.eq.nsepar) then
          c1=' '
         else if(k.eq.2.and.i.ne.nsepar) then
          c1=','
         endif
         do while(line3(n).ne.c1.and.n.ne.stringsize
     $            .and.n.ne.separ(i+1))
          n=n+1 
         enddo
         cscr16=' ' 
         call stringfiller(line4,stringsize,startc,n-1,
     $cscr16,16) 
         cscr16=trim(adjustl(cscr16))
         if(k.eq.1) read(cscr16,*) ispec
         if(k.eq.2) read(cscr16,*) linkdist(ispec,ilay)
         n=n+1
        enddo
        ! Check is based on iodine bond lenght (gas phase)
        ! https://en.wikipedia.org/wiki/Iodine
        if(linkdist(ispec,ilay).le.0.0d0.or.
     $     linkdist(ispec,ilay).gt.2.66d0) then
         write(iout,'(a)') ' Illegal specification of link atom 
     $distance.'
         write(iout,"('Layer: ',i2,', Border: ',i4,' 
     $, Link atom distance: ',a2)") ilay,ispec,linkdist(ispec,ilay)
         call mrccend(1)
        else
         write(iout,"(' Manually set link atom distance 
     $is detected. Boundary: 'i2,' Layer: ',i2)")ispec,ilay
         if(borderhand(ilay).ne.'auto') borderstat(ispec,ilay)='M'
        endif
       enddo
      endif
      return
      end
C
************************************************************************
      subroutine stringseparator(string,stringlen,ssepar,sseparlen,
     $seploc,maxsepar,nspecloc,iout)
************************************************************************
* Determines the separator places in the input string
************************************************************************
      implicit none
      integer stringlen,nspecloc,sseparlen,n,maxsepar,iout
      integer seploc(maxsepar)
      character(len=1) string(stringlen)
      character(len=sseparlen) ssepar
      nspecloc=0
      do n=1,stringlen
       if(string(n).eq.ssepar) then
        nspecloc=nspecloc+1
        if(nspecloc.gt.maxsepar) then
         write(iout,'(a)') '@stringseparator: Fatal error during 
     $string separation!'
         call mrccend(1)
        endif
        seploc(nspecloc)=n
       endif
      enddo
      return
      end
C
************************************************************************
      subroutine stringfiller(instring,instringlen,startc,endc,
     $outstring,outstringlen)
************************************************************************
* Fills the outputstring with some part of the string
************************************************************************
      implicit none
      integer instringlen,startc,endc,n,k,outstringlen
      character(len=1) instring(instringlen)
      character(len=1) outstring(outstringlen)
      k=0
      do n=startc,endc
       if((k.gt.outstringlen).or.(k.gt.instringlen)) exit
       if(instring(n).ne.' ') then
        k=k+1
        outstring(k)=instring(n)
       endif
      enddo
      return
      end
C
************************************************************************
      subroutine set_linkdist(nlay,natoms,natwdummy,borderat,nborders,
     $iout,linksym,linkdist,borderhand,atsymbol,borderstat,uval,
     $angtobohr)
************************************************************************
* Set default link atom distances
************************************************************************
      implicit none
      integer nlay,natoms,iout,ilay,i,natwdummy
      integer nborders(nlay),iborder
      integer borderat(2,natoms,nlay)
      character*1 borderstat(natoms,nlay)
      character*2 linksym(natoms,nlay)
      character*2 atsymbol(natwdummy)
      character*4 borderhand(nlay),uval
      real*8 linkdist(natoms,nlay),angtobohr
      logical llg
      ! set default link atom distances
      write(iout,'(a)') ' Setting the distance between link atoms 
     $and layer atoms...'
      llg=.true.
      do ilay=2,nlay
       if(borderhand(ilay).ne.'manu') then
        do iborder=1,nborders(ilay)
         if(borderstat(iborder,ilay).eq.'A') then
          call uppercase(atsymbol(borderat(1,iborder,ilay)),
     $                   atsymbol(borderat(1,iborder,ilay)),1)
          call uppercase(atsymbol(borderat(2,iborder,ilay)),
     $                   atsymbol(borderat(2,iborder,ilay)),1)
          call set_bonddist(atsymbol(borderat(1,iborder,ilay)),
     $linksym(iborder,ilay),linkdist(iborder,ilay),llg,uval,angtobohr)
         endif
        enddo
       endif
      enddo
      if(.not.llg) then
       write(iout,'(a)') ' Cannot set link atom distance automatically.'
       call mrccend(1)
      endif
      write(iout,'(a)') ' Done.'
      return
      end
C
CCCC
      subroutine set_bonddist(iatoms,jatoms,atomdist,llg,uval,angtobohr)
************************************************************************
* Determine bond distance
************************************************************************
      implicit none
      character*2 iatoms,jatoms
      character*4 uval
      real*8 atomdist,angtobohr
      logical llg
      ! based on average bond distances: https://cccbdb.nist.gov/expbondlengths1.asp (angstrom)
        ! ##################### jatoms = 'H ' ######################
        ! 3:Li-H
      if     (iatoms.eq.'Li'.and.jatoms.eq.'H ') then 
       atomdist=1.595d0
      ! 4:Be-H
      else if(iatoms.eq.'Be'.and.jatoms.eq.'H ') then 
       atomdist=1.335d0
      ! 5:B-H
      else if(iatoms.eq.'B '.and.jatoms.eq.'H ') then 
       atomdist=1.221d0
      ! 6:C-H
      else if(iatoms.eq.'C '.and.jatoms.eq.'H ') then 
       atomdist=1.093d0
      ! 7:N-H
      else if(iatoms.eq.'N '.and.jatoms.eq.'H ') then 
       atomdist=1.009d0
      ! 8:O-H
      else if(iatoms.eq.'O '.and.jatoms.eq.'H ') then 
       atomdist=0.966d0
      ! 9:F-H
      else if(iatoms.eq.'F '.and.jatoms.eq.'H ') then 
       atomdist=0.966d0
      ! 11:Na-H
      else if(iatoms.eq.'Na'.and.jatoms.eq.'H ') then 
       atomdist=1.887d0
      ! 12:Mg-H
      else if(iatoms.eq.'Mg'.and.jatoms.eq.'H ') then 
       atomdist=1.691d0
      ! 13:Al-H
      else if(iatoms.eq.'Al'.and.jatoms.eq.'H ') then 
       atomdist=1.613d0
      ! 14:Si-H
      else if(iatoms.eq.'Si'.and.jatoms.eq.'H ') then 
       atomdist=1.483d0
      ! 15:P-H
      else if(iatoms.eq.'P '.and.jatoms.eq.'H ') then 
       atomdist=1.423d0
      ! 16:S-H
      else if(iatoms.eq.'S '.and.jatoms.eq.'H ') then 
       atomdist=1.346d0
      ! 17:Cl-H
      else if(iatoms.eq.'Cl'.and.jatoms.eq.'H ') then
       atomdist=1.295d0
      ! 19:K-H
      else if(iatoms.eq.'K '.and.jatoms.eq.'H ') then 
       atomdist=2.243d0
      ! 20:Ca-H
      else if(iatoms.eq.'Ca'.and.jatoms.eq.'H ') then 
       atomdist=2.003d0
      ! 21:Sc-H
      else if(iatoms.eq.'Sc'.and.jatoms.eq.'H ') then 
       atomdist=1.775d0
      ! 22:Ti-H
      else if(iatoms.eq.'Ti'.and.jatoms.eq.'H ') then 
       atomdist=1.785d0
      ! 24:Cr-H
      else if(iatoms.eq.'Cr'.and.jatoms.eq.'H ') then
       atomdist=1.655d0
      ! 29:Cu-H
      else if(iatoms.eq.'Cu'.and.jatoms.eq.'H ') then
       atomdist=1.463d0
      ! 30:Zn-H
      else if(iatoms.eq.'Zn'.and.jatoms.eq.'H ') then 
       atomdist=1.565d0
      ! 31:Ga-H
      else if(iatoms.eq.'Ga'.and.jatoms.eq.'H ') then 
       atomdist=1.663d0
      ! 32:Ge-H
      else if(iatoms.eq.'Ge'.and.jatoms.eq.'H ') then
       atomdist=1.568d0
      ! 33:As-H
      else if(iatoms.eq.'As'.and.jatoms.eq.'H ') then 
       atomdist=1.523d0
      ! 34:Se-H
      else if(iatoms.eq.'Zn'.and.jatoms.eq.'H ') then
       atomdist=1.469d0
      ! 35:Br-H
      else if(iatoms.eq.'Br'.and.jatoms.eq.'H ') then
       atomdist=1.431d0
      ! 114:I-H
      else if(iatoms.eq.'I '.and.jatoms.eq.'H ') then
       atomdist=1.609d0
      ! ##################### jatoms = 'O ' ######################
      !                   ( only double bonds )
      ! 4:Be-O
      else if(iatoms.eq.'Be'.and.jatoms.eq.'O ') then
       atomdist=1.331d0
      ! 5:B-O
      else if(iatoms.eq.'B '.and.jatoms.eq.'O ') then
       atomdist=1.223d0
      ! 6:C-O
      else if(iatoms.eq.'C '.and.jatoms.eq.'O ') then
       atomdist=1.197d0
      ! 7:N-O
      else if(iatoms.eq.'N '.and.jatoms.eq.'O ') then
       atomdist=1.184d0
      ! 12:Mg-O
      else if(iatoms.eq.'Mg'.and.jatoms.eq.'O ') then
       atomdist=1.758d0
      ! 15:P-O
      else if(iatoms.eq.'P '.and.jatoms.eq.'O ') then
       atomdist=1.468d0
      ! 16:S-O
      else if(iatoms.eq.'S '.and.jatoms.eq.'O ') then
       atomdist=1.435d0
      ! 20:Ca-O
      else if(iatoms.eq.'Ca'.and.jatoms.eq.'O ') then
       atomdist=1.899d0
      ! 21:Sc-O
      else if(iatoms.eq.'Sc'.and.jatoms.eq.'O ') then
       atomdist=1.668d0
      ! 22:Ti-O
      else if(iatoms.eq.'Ti'.and.jatoms.eq.'O ') then
       atomdist=1.620d0
      ! 23:V-O
      else if(iatoms.eq.'V '.and.jatoms.eq.'O ') then
       atomdist=1.589d0
      ! 29:Cu-O
      else if(iatoms.eq.'Cu'.and.jatoms.eq.'O ') then
       atomdist=1.724d0
      ! 31:Ga-O
      else if(iatoms.eq.'Ga'.and.jatoms.eq.'O ') then
       atomdist=1.743d0
      ! ##################### jatoms = ' N' ######################
      !                   ( only triple bonds )
      ! 6:C-N
      else if(iatoms.eq.'C '.and.jatoms.eq.'N ') then
       atomdist=1.160d0
      ! 15:P-N
      else if(iatoms.eq.'P '.and.jatoms.eq.'N ') then
       atomdist=1.491d0
      else
       llg=.false.
      endif
      if(uval.eq.'bohr') atomdist=atomdist/angtobohr
      return
      end
C
************************************************************************
      subroutine set_linkcoords(nlay,natwdummy,natoms,coord,borderat,
     $iout,linkdist,nborders,borderstat,linkcoord,nlinks,linksym,
     $slinksym,ncent)
************************************************************************
* Place link atoms to layer borders
************************************************************************
      implicit none
      integer nlay,natoms,iout,ilay,layerat,nonlayerat,natwdummy,ncent
      integer nborders(nlay),iborder,xyz
      integer borderat(2,natoms,nlay),nlinks(nlay)
      character*1 borderstat(natoms,nlay)
      character*2 linksym(natoms,nlay),slinksym(natoms,nlay)
      real*8 coord(3,ncent),linkdist(natoms,nlay)
      real*8 linkcoord(3,natoms,nlay),rij
      do ilay=2,nlay
       do iborder=1,natoms
        if(borderstat(iborder,ilay).ne.' '.and.
     $     borderstat(iborder,ilay).ne.'D') then
         rij=0.0d0
         nlinks(ilay)=nlinks(ilay)+1
         slinksym(nlinks(ilay),ilay)=linksym(iborder,ilay)
         layerat=borderat(1,iborder,ilay)
         nonlayerat=borderat(2,iborder,ilay)
         rij=sqrt((coord(1,nonlayerat)-coord(1,layerat))**2.0d0
     $           +(coord(2,nonlayerat)-coord(2,layerat))**2.0d0
     $           +(coord(3,nonlayerat)-coord(3,layerat))**2.0d0)
         if(rij.ne.0.0d0) then
          do xyz=1,3
           linkcoord(xyz,nlinks(ilay),ilay)=
     $(coord(xyz,nonlayerat)-coord(xyz,layerat))*linkdist(iborder,ilay)
     $/rij+coord(xyz,layerat)
          enddo
         else
          write(iout,'(a)') ' @set_linkcoords: Fatal error during the 
     $positioning of link atoms.'
          write(iout,'(a)') ' The distance between the 
     $inner layer and the outer layer atoms is zero!'
          call mrccend(1)
         endif
         endif
       enddo
      enddo
      return
      end
C
************************************************************************
      subroutine fill_coords(natoms,natwdummy,nlay,ilay,natomslay,
     $layeratoms,icent,coord,scoord,atsymbol,satsymbol,nlinks,linkcoord,
     $linksym,qmmm,ncent,atchg,satchg,oniomtype,eecharge,ccoord,
     $ncharge,nnotlayat)
************************************************************************
* Fill the geometry and charge related arrays to generate MINP
************************************************************************
      implicit none
      integer natoms,nlay,ilay,icent,ncent,i,natwdummy
      integer natomslay(nlay),layeratoms(natoms,nlay)
      integer nlinks(nlay),iatoms,nnotlayat(nlay),ncharge(nlay)
      character*2 atsymbol(natwdummy),linksym(natoms,nlay)
      character*2 satsymbol(natwdummy)
      character*4 oniomtype
      character*8 qmmm
      real*8  coord(3,ncent),scoord(3,ncent),ccoord(3,ncent)
      real*8  linkcoord(3,natoms,nlay),eecharge(natoms)
      real*8  atchg(ncent),satchg(ncent)
      logical notlayerat
      icent=0
      ncharge(ilay)=0
      nnotlayat(ilay)=0
      do iatoms=1,natoms
       do i=1,natomslay(ilay)
        if(iatoms.eq.layeratoms(i,ilay)) then
         icent=icent+1
         scoord(1:3,icent)=coord(1:3,iatoms)
         satsymbol(icent)=atsymbol(iatoms)
        endif
       enddo
      enddo
      if(nlinks(ilay).gt.0) then
       do iatoms=1,nlinks(ilay)
        icent=icent+1
        scoord(1:3,icent)=linkcoord(1:3,iatoms,ilay)
        satsymbol(icent)=linksym(iatoms,ilay)
       enddo
      endif
      if(oniomtype.eq.'ee') then
       do iatoms=1,natoms
        notlayerat=.true.
        do i=1,natomslay(ilay)
         if(iatoms.eq.layeratoms(i,ilay)) notlayerat=.false.
        enddo
        if(notlayerat) then
         nnotlayat(ilay)=nnotlayat(ilay)+1
         ncharge(ilay)=ncharge(ilay)+1
         ccoord(1:3,ncharge(ilay))=coord(1:3,iatoms)
         satchg(ncharge(ilay))=eecharge(iatoms)
        endif
       enddo 
      endif
      if(qmmm.eq.'amber') then
       do iatoms=natoms+1,ncent
        ncharge(ilay)=ncharge(ilay)+1
        ccoord(1:3,ncharge(ilay))=coord(1:3,iatoms)
        satchg(ncharge(ilay))=atchg(iatoms)
       enddo
      endif
      return
      end
C
************************************************************************
      subroutine print_results(nsp,nlay,imet,ibas,iout,
     $scrfile1,minpfile,finalener)
************************************************************************
* Fill the geometry and charge related arrays to generate MINP
************************************************************************
      implicit none
      integer       nsp,nlay,iout,level,ilay,isp,scrfile1,i,j,minpfile
      character*2  cscr2
      character*8  cscr8
      character*15 cscr15
      character*32 imet(nlay)
      character*20 ibas(nlay)
      character*40 cscr40
      real*8       oniomener(nsp),finalener,cputime,walltime,sumcpu
      real*8       sumwall
      finalener=0.0d0
      sumcpu=0.0d0
      sumwall=0.0d0
      oniomener=0.0d0
      finalener=0.0d0
      write(iout,*)
      write(iout,"(' ======================= FINAL ONIOM RESULTS 
     $==========================')")   
      write(iout,'(a)') '   Calc.  Layer    
     $         Level                        Energy[AU]'
      ilay=1
      level=0
      open(unit=minpfile,file='iface',status='replace')
       write(minpfile,"(68a)")
     $'#property method        sym st mul        value' //
     $'             CPU(sec)       Wall(sec)'
       do isp=1,nsp ! Main loop starts
        write(cscr2,'(i2)') isp
        cscr15='iface.'//trim(adjustl(cscr2))
        open(unit=scrfile1,file=cscr15,status='old')
         read(scrfile1,*)
         i=0
         do
          read(scrfile1,*,end=7597)
          i=i+1
         enddo
7597     rewind(scrfile1)
         do j=1,i
          read(scrfile1,*)
         enddo
         read(scrfile1,7596) cscr8,cscr15,i,i,i,oniomener(isp),
     $cputime,walltime
7596  format(a8,1x,a15,1x,3(i2,1x),1pe23.15,2(1pe15.8))
         write(minpfile,7596) cscr8,cscr15,i,i,i,oniomener(isp),
     $cputime,walltime
         sumcpu=sumcpu+cputime
         sumwall=sumwall+walltime
        close(scrfile1)
        if(MOD(isp,2).eq.0) then
         ilay=ilay+1
         finalener=finalener-oniomener(isp)
        else
         finalener=finalener+oniomener(isp)
         level=level+1
        endif
        cscr40=trim(adjustl(imet(level)))//'/'//
     $trim(adjustl(ibas(level)))
        write(iout,"(1x,i4,4x,i4,9x,a24,1x,f24.16)")
     $isp, ilay,cscr40,
     $oniomener(isp)
       enddo
      close(minpfile)
      write(iout,*)
      write(iout,"(' ***FINAL ONIOM ENERGY:       ',F24.16,' [AU]')")
     $finalener 
      write(iout,*)
      write(iout,'(a)') ' ==============================================
     $========================'
      open(unit=scrfile1,file='iface',status='old',position='append')
       write(scrfile1,7596) 'ENERGY  ','ONIOMENER      ',1,1,1,
     $finalener,sumcpu,sumwall
      close(scrfile1)
      return
      end
C
************************************************************************
      subroutine get_keylist(minpfile,istring,stringsize,scrfile1,nkeys)
************************************************************************
* Collect the user-specified keywords from the minp file
************************************************************************
      implicit none
      integer minpfile,stringsize,i,j,nkeys,scrfile1
      character(len=stringsize) istring
      character*1 line1(512),cscr64v(64)
      character*64 cscr64
      character*512 line
      equivalence(line,line1)
      equivalence(cscr64,cscr64v)
      istring=' '
      nkeys=0
      ! read keyword list from the MINP file
      open(minpfile,file='MINP')
       rewind(minpfile)
       do
        read(minpfile,'(512a1)',end=1000) line1
        call lowercase(line,line,512)
        line=adjustl(line)
        if(line1(1).ne.' ') then
         i=1
         cscr64=' '
         do while(line1(i).ne.'='.and.i.ne.64)
          cscr64v(i)=line1(i)
          i=i+1
         enddo
         ! read keyword from KEYWD file
         open(scrfile1,file='KEYWD')
          rewind(scrfile1)
          do 
           read(scrfile1,'(512a1)',end=1001) line1  
           call lowercase(line,line,512)
           line=adjustl(line)
           j=1
           do while(line1(j).ne.'='.and.j.ne.512)
            j=j+1
           enddo
           ! add keyword if it is specified in both lists
           if(trim(adjustl(cscr64)).eq.line(1:j-1)) then
            nkeys=nkeys+1
            istring=trim(adjustl(istring))//' '//trim(adjustl(cscr64))
           endif
          enddo
1001      continue
         close(scrfile1)
        endif
       enddo
1000  continue
      close(minpfile)
      return
      end
C
************************************************************************
      subroutine get_pcmkeylist(minpfile,pcmkeystring,stringsize,
     $npcmdefkeys,pcmkeys,npcmkeys)
************************************************************************
* Collect the user-specified keywords from the minp file
************************************************************************
      implicit none
      integer minpfile,stringsize,i,j,k,npcmdefkeys,npcmkeys
      character(len=stringsize) pcmkeystring,pcmkeys
      character*1 line1(512),cscr64v(64)
      character*64 cscr64,cscr
      character*512 line
      logical llg
      equivalence(line,line1)
      equivalence(cscr64,cscr64v)
      pcmkeystring=' '
      npcmdefkeys=0
      ! read keyword list from the MINP file
      open(minpfile,file='MINP')
       rewind(minpfile)
       do
        llg=.false.
        read(minpfile,'(512a1)',end=1000) line1
        call lowercase(line,line,512)
        line=adjustl(line)
        if(line1(1).ne.' ') then
         i=1
         cscr64=' '
         do while(line1(i).ne.'='.and.i.ne.64)
          cscr64v(i)=line1(i)
          i=i+1
         enddo
         ! read keyword from PCM key list
         do j=1,npcmkeys
          if(j.eq.1) then
           read(pcmkeys,*) cscr
          else
           read(pcmkeys,*) (line1(k),k=1,j-1),cscr
          endif
          if(trim(adjustl(cscr64)).eq.trim(adjustl(cscr))) llg=.true.
         enddo
         if(llg) then
          pcmkeystring=trim(adjustl(pcmkeystring))//' '
     $               //trim(adjustl(cscr64))
          npcmdefkeys=npcmdefkeys+1
         endif
        endif
       enddo
1000  continue
      close(minpfile)
      return
      end
C
************************************************************************
      subroutine get_nonmust_keylist(istring,stringsize,nkeys,
     $fstring,fstringsize,nkeysnon)
************************************************************************
* Filter out those keywords which are controlled by the oniom run
************************************************************************
      implicit none
      integer stringsize,nkeys,fstringsize,i,noutkeys,nkeysnon
      integer k,j
      character*1 line1(512)
      character*64 cscr,cscr2
      character*512 line
      character(len=stringsize) istring
      character(len=stringsize) cscrstring
      character(len=fstringsize) fstring
      logical llg
      equivalence(line,line1)
      noutkeys=0
      cscrstring=istring
      istring=' '
      do i=1,nkeys
       llg=.true.
       if(i.eq.1) then
        read(cscrstring,*) cscr
       else
        read(cscrstring,*) (line1(k),k=1,i-1),cscr
       endif
       do j=1,nkeysnon
        if(j.eq.1) then
         read(fstring,*) cscr2
        else
         read(fstring,*) (line1(k),k=1,j-1),cscr2
        endif
        if(trim(adjustl(cscr)).eq.trim(adjustl(cscr2))) llg=.false.
       enddo
       if(llg) then
        istring=trim(adjustl(istring))//' '//trim(adjustl(cscr))
       else
        nkeys=nkeys-1
       endif
      enddo
      return
      end
C
************************************************************************
      subroutine get_complete_keys(minpfile,istring,istringsize,
     $nkeys)
************************************************************************
* Add value to the remaining keywords
************************************************************************
      implicit none
      integer istringsize,nkeys,minpfile,i,k
      character*1 line1(512)
      character*64 cscr,cscr2
      character*512 line,linex
      character(len=istringsize) istring
      character(len=istringsize) cscrstring
      logical llg
      equivalence(line,line1)
      cscrstring=' '
      open(minpfile,file='MINP')
       do i=1,nkeys
        linex=' '
        if(i.eq.1) then
         read(istring,*) line
        else
         read(istring,*) (line1(k),k=1,i-1),line
        endif 
        line=trim(adjustl(line))
        k=1
        do while(line1(k+1).ne.' ')
         k=k+1
        enddo
        call getkeym(line,k,linex,512)
        line=trim(adjustl(line))//'='//trim(adjustl(linex))
        cscrstring=trim(adjustl(cscrstring))//' '//trim(adjustl(line))
       enddo
      close(minpfile) 
      istring=cscrstring
      return
      end
C
************************************************************************
      subroutine read_oniomspec(scrfile1,nlay,natwdummy,natoms,
     $layeratoms,natomslay,imet,ibas,ichg,imul,borderat,borderhand,
     $linksym,linkdist,borderstat,keywstring,kstringlen,nkeys,pcmstring,
     $pcmstringlen,npcmdefkeys,eecharge)
************************************************************************
* Read variables which were previously set
************************************************************************
      implicit none
      integer scrfile1,nlay,natwdummy,natoms,kstringlen,ilay,j
      integer layeratoms(natoms,nlay),natomslay(nlay)
      integer ichg(nlay),imul(nlay),borderat(2,natoms,nlay)
      integer iborder,nborder,i,k,nkeys,npcmdefkeys,pcmstringlen
      character*1 borderstat(natoms,nlay)
      character*2 linksym(natoms,nlay)
      character*4 borderhand(nlay)
      character*20 ibas(nlay)
      character*32 imet(nlay)
      character(len=kstringlen) keywstring
      character(len=pcmstringlen) pcmstring
      real*8 linkdist(natoms,nlay),eecharge(natoms)
      open(scrfile1,file='ONIOMSPEC',form='UNFORMATTED')
       read(scrfile1) 
       read(scrfile1)
       do ilay=1,nlay
        read(scrfile1) natomslay(ilay)
        read(scrfile1) (layeratoms(k,ilay),k=1,natomslay(ilay))
        read(scrfile1) imet(ilay),ibas(ilay),ichg(ilay),imul(ilay),
     $borderhand(ilay)
       enddo
       read(scrfile1)
       read(scrfile1) nkeys,keywstring
       read(scrfile1) npcmdefkeys,pcmstring
       read(scrfile1) 
       do ilay=2,nlay
        read(scrfile1) nborder
        do iborder=1,nborder
         read(scrfile1) i
         read(scrfile1) borderstat(i,ilay)
         if(borderstat(i,ilay).ne.'D') then
          backspace(scrfile1)
          read(scrfile1) 
     $borderstat(i,ilay),
     $borderat(1,i,ilay),borderat(2,i,ilay),
     $linksym(i,ilay),linkdist(i,ilay)
         endif
        enddo
       enddo
       read(scrfile1)
       read(scrfile1)
       read(scrfile1) (eecharge(j),j=1,natoms)
      close(scrfile1)
      return
      end
C
************************************************************************
      subroutine oniomgrad(natoms,natwdummy,nlay,natomslay,
     $layeratoms,icent,coord,scoord,atsymbol,satsymbol,nlinks,
     $linkcoord,slinksym,ncent,atchg,satchg,nsp,iout,scrfile1,
     $borderat,linkdist,angtobohr,uval,force,efield,echesu,finalener,
     $qmmm,ncharge,oniomtype,eecharge)
************************************************************************
* Read and collect forces on the atoms 
************************************************************************
      implicit none
      integer natoms,natwdummy,nlay,icent,ncent,nsp,isp,ilay,ios
      integer natomslay(nlay),layeratoms(natoms,nlay),i,iborder
      integer nlinks(nlay),iatoms,jatoms,iout,scrfile1
      integer borderat(2,natoms,nlay),ncharge(nlay) 
      real*8 coord(3,ncent),scoord(3,ncent)
      real*8 force(3,ncent),efield(3,ncent)
      real*8 linkcoord(3,natoms,nlay),fact,angtobohr,echesu,finalener
      real*8 atchg(ncent),satchg(ncent),eecharge(natoms)
      real*8 linkdist(natoms,nlay),selfener,dipxyz(3),rscr(3)
      character*2 atsymbol(natwdummy),satsymbol(natwdummy)
      character*2 slinksym(natoms,nlay),cscr2
      character*4 uval,oniomtype
      character(len=8) read_buffer,qmmm
      logical llg
      ilay=1
      force=0.0d0
      do isp=1,nsp
       if(MOD(isp,2).eq.0) then
        ilay=ilay+1
        fact=-1.0d0
       else
        fact=1.0d0
       endif
       write(cscr2,'(i2)') isp
       cscr2=trim(adjustl(cscr2))
       inquire(file='GRAD.'//cscr2,exist=llg)
       if(llg) then
        open(scrfile1,file='GRAD.'//cscr2,form='unformatted')
         rewind(scrfile1)
         ! read non-link atoms
         do iatoms=1,natomslay(ilay)
          read(scrfile1) scoord(1:3,iatoms)
         enddo
         ! read link atoms
         if(nlinks(ilay).ne.0) then
          do iborder=1,nlinks(ilay)
           read(scrfile1) linkcoord(1:3,iborder,ilay)
           ! distribute forces
           call distribute_link_forces(ncent,natwdummy,coord,
     $linkcoord(1:3,iborder,ilay),borderat(1,iborder,ilay),
     $borderat(2,iborder,ilay),linkdist(iborder,ilay),angtobohr,
     $uval,fact,force)
          enddo
         endif
        close(scrfile1)
       else
        write(iout,'(a)') ' Error in ONIOM gradient calculation.'
        write(iout,'(a,a,a)') 
     $' GRAD.'//trim(adjustl(cscr2))//' is missing!'
        call mrccend(1)
       endif
       do iatoms=1,natomslay(ilay)
        force(1:3,layeratoms(iatoms,ilay))=fact*scoord(1:3,iatoms)
     $ +force(1:3,layeratoms(iatoms,ilay))
       enddo
      enddo
      if(((qmmm.ne.'off').and.(natoms.ne.ncent)).or.
     $   (oniomtype.eq.'ee')) then
       ilay=1
       do isp=1,nsp
        if(MOD(isp,2).eq.0) then
         ilay=ilay+1
         fact=-1.0d0
        else
         fact=1.0d0
        endif
        write(cscr2,'(i2)') isp
        cscr2=trim(adjustl(cscr2))
        scoord=0.0d0
        if(qmmm.ne.'off'.or.(oniomtype.eq.'ee'.and.isp.gt.1)) then
         inquire(file='mrcc_job.dat.'//cscr2,exist=llg)
         if(llg) then
          open(scrfile1,file='mrcc_job.dat.'//cscr2,form='formatted')
           rewind(scrfile1)
           do
            read(scrfile1,'(a)',iostat=ios) read_buffer
            ! End of file; data not found
            if(ios.lt.0) exit
            if(read_buffer(2:5).eq.'Elec') then
             if     (oniomtype.eq.'me') then
              do iatoms=natoms+1,ncent
               read(scrfile1,'(3e23.15)') scoord(1:3,iatoms)
              enddo
             else if(oniomtype.eq.'ee') then
              do iatoms=1,ncent
               llg=.true.
               do jatoms=1,natomslay(ilay)
                if(layeratoms(jatoms,ilay).eq.iatoms) llg=.false.
               enddo 
               if((llg).or.(iatoms.gt.natoms)) then
                read(scrfile1,'(3e23.15)') scoord(1:3,iatoms)
               endif
              enddo
             endif
            endif
            if(read_buffer(2:5).eq.'Dire' ) then
             read(scrfile1,'(3e23.15)') rscr(1), rscr(2), rscr(3)
            endif
           enddo
          close(scrfile1)
         else
          write(iout,'(a)') ' Error in ONIOM gradient calculation.'
          write(iout,'(a,a,a)')
     $' mrcc_job.dat.'//trim(adjustl(cscr2))//' is missing!'
          call mrccend(1)
         endif
        endif
        if(isp.eq.1) then
         call ishell('cp VARS.'//cscr2//' VARS')
         call getvar('selfenergy',selfener)
        endif
        if     (oniomtype.eq.'me') then
         do iatoms=natoms+1,ncent
          efield(1:3,iatoms)=fact*scoord(1:3,iatoms)
     $   +efield(1:3,iatoms)
         enddo
        else if(oniomtype.eq.'ee') then
         do iatoms=1,ncent
          llg=.true.
          do jatoms=1,natomslay(ilay)
           if(layeratoms(jatoms,ilay).eq.iatoms) llg=.false.
          enddo
          if(llg) then
           force(1:3,iatoms)=
     $     fact*scoord(1:3,iatoms)*(-1.0d0)*eecharge(iatoms)
     $    +force(1:3,iatoms)
          endif
          if(iatoms.gt.natoms) then
           efield(1:3,iatoms)=fact*scoord(1:3,iatoms)
     $    +efield(1:3,iatoms)
          endif
         enddo
        endif
        dipxyz(1)=dipxyz(1)+rscr(1)*fact
        dipxyz(2)=dipxyz(2)+rscr(2)*fact
        dipxyz(3)=dipxyz(3)+rscr(3)*fact
       enddo
      endif
      write(iout,*)
      write(iout,*) 'Cartesian gradient [au]:' 
      open(scrfile1,file='GRAD',status='replace',form='unformatted')
       do iatoms=1,natoms
        write(scrfile1) force(1:3,iatoms)
        write(iout,'(i5,1x,a3,3f17.10)') iatoms,atsymbol(iatoms),
     $force(1:3,iatoms)
       enddo
      close(scrfile1)
      call ishell('cp GRAD GRAD.composite')
      if(qmmm.ne.'off') then
       open(scrfile1,file='mrcc_job.dat',form='formatted',
     $                                   status='old')
        write(scrfile1,'(a)')
        ! Forces on QM atoms
        write(scrfile1,'(a)') ' Forces on QM atoms [Hartree/Bohr]'
        do iatoms=1,natoms
         write(scrfile1,"(3e23.15)")
     $   force(1,iatoms),force(2,iatoms),force(3,iatoms)
        enddo
        ! Electric field
        write(scrfile1,'(a)')
        write(scrfile1,'(a)') ' Electric field at MM atoms'
        do iatoms=natoms+1,ncent
         write(scrfile1,"(3e23.15)")
     $   efield(1,iatoms),efield(2,iatoms),efield(3,iatoms)
        enddo
        ! Dipole moment
        write(scrfile1,'(a)')
        write(scrfile1,'(a)') 
     $' Magnitude of dipole moment vector [Debye]'
        write(scrfile1,'(e23.15)')
     $echesu*angtobohr*dsqrt(dipxyz(1)**2+dipxyz(2)**2+dipxyz(3)**2)
        write(scrfile1,'(a)') 
     $' Direction of dipole moment vector [Debye]'
        write(scrfile1,"(3e23.15)") 
     $  echesu*angtobohr*dipxyz(1),
     $  echesu*angtobohr*dipxyz(2),
     $  echesu*angtobohr*dipxyz(3) 
        write(scrfile1,'(a)')
        ! Final energy
        write(scrfile1,'(a)') '  Final energy of the QM region [AU]'
        write(scrfile1,'(e23.15)') finalener
        ! Self energy
        write(scrfile1,'(a)')'  Self energy of the point charges [AU]'
        write(scrfile1,'(e23.15)') selfener
       close(scrfile1)
       call ishell('cp mrcc_job.dat mrcc_job.dat.composite')
      endif
      return
      end
C
************************************************************************
      subroutine distribute_link_forces(ncent,natwdummy,coord,
     $linkcoord,iborderat,jborderat,linkdist,angtobohr,uval,
     $fact,force)
************************************************************************
* Distribute forces acting on the link atoms
************************************************************************
      implicit none
      integer natwdummy,iborderat,jborderat,xyz,ncent
      real*8 linkcoord(3),linkdist,angtobohr,fact
      real*8 coord(3,ncent),dij(3),rij,scafact,dotprod
      real*8 force(3,ncent),q(3),conv
      character*4 uval
      dij=0.0d0
      dotprod=0.0d00
      if(uval.eq.'bohr') then
       conv=angtobohr
      else
       conv=1.0d0
      endif
      dij(1)=(coord(1,jborderat)-coord(1,iborderat))/conv
      dij(2)=(coord(2,jborderat)-coord(2,iborderat))/conv
      dij(3)=(coord(3,jborderat)-coord(3,iborderat))/conv
      rij=sqrt(dij(1)**2.0d0+dij(2)**2.0d0+dij(3)**2.0d0)
      scafact=linkdist/rij
      dij(1)=dij(1)/rij
      dij(2)=dij(2)/rij
      dij(3)=dij(3)/rij
      q=0.0d0
      dotprod=linkcoord(1)*dij(1)
     $       +linkcoord(2)*dij(2)
     $       +linkcoord(3)*dij(3)
      do xyz=1,3
       q(xyz)=scafact*(linkcoord(xyz)-dotprod*dij(xyz))
       force(xyz,iborderat)=force(xyz,iborderat)
     $+(linkcoord(xyz)-q(xyz))*fact
       force(xyz,jborderat)=force(xyz,jborderat)
     $+q(xyz)*fact
      enddo
      return
      end
C
************************************************************************
      subroutine cleaup_oniom(nsp,minpfile)
************************************************************************
* Clean files of the previous subcalculations
************************************************************************       
      implicit none
      integer               :: isp,nsp,minpfile
      character(len=2)      :: cscr2
      character(len=16)     :: cscr16
      logical               :: llg
      do isp=1,nsp
       write(cscr2,'(i2)') isp
       cscr16='MINP.'//trim(adjustl(cscr2))
       inquire(file=cscr16,exist=llg)
       if(llg) then
        open(minpfile,file=cscr16)
        close(minpfile,status='delete')
       endif
       cscr16='KEYW.'//trim(adjustl(cscr2))
       inquire(file=cscr16,exist=llg)
       if(llg) then
        open(minpfile,file=cscr16)
        close(minpfile,status='delete')
       endif
       cscr16='GRAD.'//trim(adjustl(cscr2))
       inquire(file=cscr16,exist=llg)
       if(llg) then
        open(minpfile,file=cscr16)
        close(minpfile,status='delete')
       endif
       cscr16='VARS.'//trim(adjustl(cscr2))
       inquire(file=cscr16,exist=llg)
       if(llg) then
        open(minpfile,file=cscr16)
        close(minpfile,status='delete')
       endif
      enddo
      inquire(file='ONIOMROUTE',exist=llg)
      if(llg) then
       open(minpfile,file='ONIOMROUTE')
       close(minpfile,status='delete')
      endif
      inquire(file='ATCHARGE',exist=llg)
      if(llg) then
       open(minpfile,file='ATCHARGE')
       close(minpfile,status='delete')
      endif
      inquire(file='BONDTABLE',exist=llg)
      if(llg) then
       open(minpfile,file='BONDTABLE')
       close(minpfile,status='delete')
      endif
      inquire(file='VARS',exist=llg)
      if(llg) then
       open(minpfile,file='VARS')
       close(minpfile,status='delete')
      endif
      return
      end
C
************************************************************************
      subroutine get_layernumber_oniomtype(oniom,nlay,oniomtype)
************************************************************************
* Analyze the 'oniom' keyword to get the number of layers and
* the type of ONIOM calculation 
* (mechanical embedding=me / electronic embedding=ee)
************************************************************************ 
      implicit none
      character(len=1)  :: vline(8),vline2(8)
      character(len=4)  :: oniomtype
      character(len=8)  :: oniom,line,line2
      integer           :: nlay,i
      logical           :: llg
      equivalence(line,vline)
      equivalence(line2,vline2)
      call lowercase(oniom,oniom,8)
      line=oniom
      line2=' '
      i=1
      llg=.false.
      do while(vline(i).ne.' '.and.i.lt.8)
       if(vline(i).eq.'-') then
        vline2(1:i-1)=vline(1:i-1)
        read(line2,*) nlay
        llg=.true.
        line2=' '
        vline2(i+1:8)=vline(i+1:8)
        oniomtype=trim(adjustl(line2))
       endif
       i=i+1
      enddo
      if(.not.llg) then
       read(oniom,*) nlay
       oniomtype='me  '
      endif
      return
      end
C
************************************************************************
      subroutine get_nmmcharges(minpfile,natwdummy,ncent,qmmm)
************************************************************************
* Read the number of point charges
************************************************************************
      implicit none
      character(len=8) :: qmmm,cscr8
      integer          :: nmmat,ncent,natwdummy,minpfile      
      nmmat=0
      if(qmmm.eq.'amber') then
       open(minpfile,file='MINP')
        rewind(minpfile)
        cscr8='        '
        do while(cscr8.ne.'pointcha')
         read(minpfile,"(a8)") cscr8
        enddo
        read(minpfile,*) nmmat
       close(minpfile)
       ncent=natwdummy+nmmat
      else
       ncent=natwdummy
      endif
      return
      end
C
************************************************************************
      subroutine read_eecharge(oniom_eechg,eecharge,natoms,scrfile1,
     $iout,minpfile)
************************************************************************
* Read the atomic charges for electronic embedding
************************************************************************
      implicit none
      character(len=2) :: cscr2
      character(len=8) :: oniom_eechg
      integer          :: i,iatoms,scrfile1,natoms,iout,minpfile
      integer          :: nqmatoms
      real*8           :: rscr,eecharge(natoms)
      logical          :: lexist
      lexist=.false.
      if(oniom_eechg.eq.'mulli'.or.oniom_eechg.eq.'lowdin'.or.
     $   oniom_eechg.eq.'iao') then
       inquire(file='ATCHARGE',exist=lexist) 
       if(lexist) then
        open(scrfile1,file='ATCHARGE',form='UNFORMATTED')
         rewind(scrfile1)
         if     (oniom_eechg.eq.'mulli') then
          do iatoms=1,natoms
           read(scrfile1) i,cscr2,eecharge(i)
          enddo
         else if(oniom_eechg.eq.'lowdin') then
          do iatoms=1,natoms
           read(scrfile1) i,cscr2,rscr,eecharge(i)
          enddo
         else if(oniom_eechg.eq.'iao') then
          do iatoms=1,natoms
           read(scrfile1) i,cscr2,rscr,rscr,eecharge(i)
          enddo
         endif
        close(scrfile1)
       endif
      else if(oniom_eechg.eq.'amber') then
       inquire(file='QMCHARGES',exist=lexist)
       if(lexist) then
        open(scrfile1,file='QMCHARGES',form='FORMATTED')
         rewind(scrfile1)
         read(scrfile1,*) nqmatoms
         do iatoms=1,nqmatoms
          read(scrfile1,'(e23.15)') eecharge(iatoms)
         enddo
         do iatoms=nqmatoms+1,natoms
          eecharge(iatoms)=0.0d0
         enddo
        close(scrfile1)
       endif
      else if(oniom_eechg.eq.'user') then
       open(minpfile,file='MINP.composite')
        call getkeym('oniom_eechg',11,oniom_eechg,8)
        do iatoms=1,natoms
         read(minpfile,*) eecharge(iatoms)
        enddo
       close(minpfile)
      endif
      if(.not.lexist.and.oniom_eechg.ne.'user') then
       write(iout,'(a)') ' Cannot find atomic charges.'
       call mrccend(1)
      endif
      return
      end
C
************************************************************************
      subroutine oniomdriverinit(firstcall,usetemp,borderhand,linkdist,
     $imet,ibas,borderstat,sdens,nlinks,borderstring,linkstring,
     $diststring,coord,force,efield,atchg,eecharge,layeratoms,borderat,
     $linksym,pcmkeystring,mrcckeys,nmrcckeys,pcmkeys,npcmkeys,
     $nkeys,npcmdefkeys,nkeysnon,subminp,verbosity,dens,geom,uval,
     $orblocc,orbloco,orbloce,moldenval,mpitasks,pcm,oniom_pcm,
     $oniom_eechg,ncent,natoms,natwdummy,slinksym,nlay,keywstring,
     $filterstring,iout,oniomtype)
************************************************************************
* Initalize variables for oniomdriver
************************************************************************
      implicit none
      integer natoms,nlay,ncent,natwdummy,nkeys,nkeysnon,iout
      integer nborders(nlay),layeratoms(natoms,nlay),natomslay(nlay)
      integer borderat(2,natoms,nlay),nlinks(nlay)
      integer nmrcckeys,npcmkeys,npcmdefkeys
      character*1 borderstat(natoms,nlay)
      character*2 linksym(natoms,nlay),slinksym(natoms,nlay)
      character*3 moldenval
      character*4 verbosity,dens,geom,uval,sdens,mpitasks
      character*4 borderhand(nlay),oniomtype
      character*7 scfiguess
      character*8 gopt,qmmm,freq,subminp,oniom_pcm,oniom_eechg
      character*16 orbloco,orblocc,orbloce
      character*20 ibas(nlay)
      character*32 imet(nlay),pcm
      character*1024 pcmkeys,pcmkeystring,mrcckeys
      character*1024 filterstring
      character*2048 keywstring
      character(len=natoms*8*8) istring
      character(len=natoms*4*8) borderstring(nlay)
      character(len=natoms*3*8) linkstring(nlay),diststring(nlay)
      real*8 coord(3,ncent),atchg(ncent),linkdist(natoms,nlay)
      real*8 force(3,ncent),efield(3,ncent)
      real*8 eecharge(natoms)
      logical usetemp,firstcall
      firstcall=.true.
      usetemp=.false.
      borderhand(1:nlay)='    '
      linkdist=0.0d0
      imet=' '
      ibas=' '
      borderstat=' '
      sdens='    '
      nlinks=0
      borderstring=' '
      linkstring=' '
      diststring=' '
      coord=0.0d0
      force=0.0d0
      efield=0.0d0
      atchg=0.0d0
      eecharge=0.0d0
      layeratoms=0
      borderat=-1
      linksym='  '
      slinksym='  '
      istring=' '
      pcmkeystring=' '
      keywstring=' '
      mrcckeys='mem      qmmm   gopt          freq        calc 
     $          basis    charge mult          verbosity   test 
     $          qmreg    oniom  geom          subminp     dens 
     $          mpitasks pcm    oniom_pcm     oniom_eechg     '
      nmrcckeys=19
      pcmkeys='pcm_cavity_type
     $         pcm_cavity_area  
     $         pcm_cavity_scaling
     $         pcm_cavity_radiiset 
     $         pcm_cavity_npzfile 
     $         pcm_cavity_minradius
     $         pcm_medium_solvertype
     $         pcm_medium_correction
     $         pcm_medium_solvent
     $         pcm_medium_proberadius
     $         pcm_green_eps
     $         pcm_green_type'
      npcmkeys=12
      filterstring=trim(adjustl(mrcckeys))//' '//trim(adjustl(pcmkeys))
      nkeysnon=nmrcckeys+npcmkeys
      nkeys=0
      npcmdefkeys=0
      call getkey('subminp',7,subminp,8)
      call getkey('verbosity',4,verbosity,4)
      call getkey('dens',4,dens,4)
      call getkey('geom',4,geom,4)
      call getkey('unit',4,uval,4)
      call getkey('orblocc',7,orblocc,16)
      call getkey('orbloco',7,orbloco,16)
      call getkey('orbloce',7,orbloce,16)
      call getkey('molden',6,moldenval,3)
      call getkey('mpitasks',8,mpitasks,4)
      call getkey('pcm',3,pcm,32)
      call getkey('oniom_pcm',9,oniom_pcm,8)
      call getkey('oniom_eechg',11,oniom_eechg,8)
      if(oniom_eechg.eq.'off') oniomtype='me'
      if(geom.eq.'zmat'.and.qmmm.ne.'off') then
       write(iout,'(a)') ' QM/MM calculation is not supported with the 
     $zmat input format.'
       call mrccend(1)
      endif
      return
      end
C
************************************************************************
      subroutine get_firstcall(firstcall,moldenval,qmmm,gopt,freq,
     $scrfile1,minpfile) 
************************************************************************
* Determine if ONION is already used or not
************************************************************************
      implicit none
      integer           :: niter,ios,minpfile,scrfile1
      character(len=3)  :: moldenval
      character(len=4)  :: qmmm,gopt,freq
      character(len=16) :: cscr16
      logical           :: lexist,firstcall
      inquire(file='ITER',exist=lexist)
      if((gopt.ne.'off     '.or.freq.ne.'off     ').and.lexist) then
       firstcall=.false.
       open(scrfile1,file='ITER')
        read(scrfile1,*) niter
       close(scrfile1)
       if(niter.gt.0) then
        firstcall=.false.
        if(moldenval.ne.'off') then
         call ishell('cp MOLDEN MOLDEN.composite')
        endif
       endif
      endif
      inquire(file='ONIOMSPEC',exist=lexist)
      if(qmmm.ne.'off'.and.lexist) then
       open(minpfile,file='MINP')
        rewind(minpfile)
         do
          read(minpfile,'(a)',iostat=ios) cscr16
          ! End of file; data not found
          if(ios.lt.0) exit
          if(cscr16.eq.'! Non-first MRCC') then
           firstcall=.false.
           exit
          endif
         enddo
       close(minpfile)
      endif
      return
      end
C

